

/*
 *  Global Switches
 */

#define SAC_DO_CHECK           0
#define SAC_DO_CHECK_TYPE      0
#define SAC_DO_CHECK_BOUNDARY  0
#define SAC_DO_CHECK_MALLOC    0
#define SAC_DO_CHECK_ERRNO     0
#define SAC_DO_CHECK_HEAP      0

#define SAC_DO_PHM             1
#define SAC_DO_APS             1
#define SAC_DO_DAO             1
#define SAC_DO_MSCA            1

#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0

#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_AA        0
#define SAC_DO_TRACE_MT        0

#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_GLOBAL 1
#define SAC_DO_CACHESIM_FILE   0
#define SAC_DO_CACHESIM_PIPE   0
#define SAC_DO_CACHESIM_IMDT   1

#define SAC_DO_MULTITHREAD     0
#define SAC_DO_THREADS_STATIC  1

#define SAC_DO_COMPILE_MODULE  0



/*
 *  Global Settings
 */

#ifndef NULL
#define NULL                      (void*) 0
#endif

#define SAC_SET_INITIAL_MASTER_HEAPSIZE      1048576
#define SAC_SET_INITIAL_WORKER_HEAPSIZE      65536
#define SAC_SET_INITIAL_UNIFIED_HEAPSIZE     0

#ifndef SAC_SET_MTMODE
#define SAC_SET_MTMODE               0
#endif

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX          32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS              1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS          0
#endif

#define SAC_SET_MAX_SYNC_FOLD        0
#define SAC_SET_NUM_SCHEDULERS       0

#define SAC_SET_CACHE_1_SIZE         -1
#define SAC_SET_CACHE_1_LINE         4
#define SAC_SET_CACHE_1_ASSOC        1
#define SAC_SET_CACHE_1_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_1_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_2_SIZE         -1
#define SAC_SET_CACHE_2_LINE         4
#define SAC_SET_CACHE_2_ASSOC        1
#define SAC_SET_CACHE_2_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_2_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_3_SIZE         -1
#define SAC_SET_CACHE_3_LINE         4
#define SAC_SET_CACHE_3_ASSOC        1
#define SAC_SET_CACHE_3_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_3_MSCA_FACTOR  0.00

#define SAC_SET_CACHESIM_HOST        ""
#define SAC_SET_CACHESIM_FILE        "a.out.cs"
#define SAC_SET_CACHESIM_DIR         "/tmp"
#define SAC_SET_MAXFUN               0
#define SAC_SET_MAXFUNAP             1



/*
 *  Includes
 */


#include "sac.h"


/*
 *  SAC-Program ipdd.sac :
 */


/*
 *  type definitions
 */

SAC_ND_TYPEDEF( (SACt_World__World, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_Terminal__Terminal, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_TermFile__TermFile, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_ComplexBasics__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_Complex__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_List__list, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_IOresources__TermFile, (SCL, (HID, (NUQ,)))), SACt_TermFile__TermFile)


/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()
SAC_HM_DEFINE()


/*
 *  prototypes for externals (FUNDECS)
 */

extern 
/*
 * ND_FUN_DEC( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SAC_hidden, (SACl_stream, (SCL, (HID, (NUQ,)))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, int, (SACl_a, (AUD, (NHD, (NUQ,)))))
 */
void ARRAYIO__PrintIntArray( SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ,)))), SAC_hidden), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( ARRAYIO__PrintDoubleArray, , 4, inout_nodesc_bx, SAC_hidden, (SACl_stream, (SCL, (HID, (NUQ,)))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, double, (SACl_a, (AUD, (NHD, (NUQ,)))))
 */
void ARRAYIO__PrintDoubleArray( SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ,)))), SAC_hidden), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), double));



/*
 *  prototypes for locals (FUNDEFS)
 */

extern 
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init();

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double));

extern 
/*
 * ND_FUN_DEC( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));



/*
 *  global objects
 */

/*
 * ND_OBJDEF_EXTERN( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()



/*
 *  function definitions (FUNDEFS)
 */

/* wrapper function */
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_cwc_470, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_cwc_470, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_cwc_470, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN__main, , 1, out, (SACp_cwc_470, (SCL, (NHD, (NUQ,)))))
   */
  SACf__MAIN__main( SAC_ND_ARG_out( (SACp_cwc_470, (SCL, (NHD, (NUQ,))))));

  /*
   * ND_REFRESH__MIRROR( (SACp_cwc_470, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOOP()

  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_470, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_470, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10804__emal_10758__pinl_10749____flat_49, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10804__emal_10758__pinl_10749____flat_49, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10804__emal_10758__pinl_10749____flat_49, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10803__emal_10757__pinl_10748____flat_51, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10803__emal_10757__pinl_10748____flat_51, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10803__emal_10757__pinl_10748____flat_51, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10801__emal_10755__pinl_10746____flat_46, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10801__emal_10755__pinl_10746____flat_46, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10801__emal_10755__pinl_10746____flat_46, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), double, 1, 250000)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0) = 250000;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,))))) = 250000;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), double, 2, 500, 500)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 0) = 500;
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 1) = 500;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,))))) = 250000;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), double, 2, 500, 500)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 0) = 500;
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1) = 500;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,))))) = 250000;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), double, 2, 500, 500)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 0) = 500;
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1) = 500;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,))))) = 250000;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), double, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN_CL_INIT__init, , 0)
   */
  SACf__MAIN_CL_INIT__init();

  SAC_ND_ALLOC_BEGIN( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 2, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,))))) == 0), 41, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 2, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 0.0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,))))) == 1), 195, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 0) == 1), 195, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 1, 1, 1, )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), 0, 1, )

  SAC_ND_ALLOC_BEGIN( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,))))) == 0), 304, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, 250000)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,))))) == 1), 32, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0) == 250000), 32, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,))))) == 0), 32, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,))))) == 0), 32, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), 1)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, 250000)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 250000;

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    SAC_ND_WRITE( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 0, 250000, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5, SAC_ND_READ( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * WL_ASSIGN( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,))))))), 32, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), 0)), 32, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_10783__pinl_7156____flat_2__SSA12_1, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_10607__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), 0, 250000, 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, 250000)
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_LABEL( _comp_10808_SAC_label)
  SAC_ND_FREE( (SACp_wlidx_10737__pinl_7064__z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_10610___nt2ot_307, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC__DESC( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2)
  SAC_ND_FREE__DESC( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))))
  /*
   * ND_ASSIGN__DESC( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))))
   */
  SAC_ND_A_DESC( (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))));

  SAC_ND_SET__RC( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2, 500, 500)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,))))) == 2), 62, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 0) == 500), 62, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 1) == 500), 62, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ASSIGN__DATA( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), (SACp_emal_10781__pinl_7064__z, (AKS, (NHD, (NUQ,)))), )
  SAC_NOOP( )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1, 2)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, 500, 500)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,))))) == 2), 177, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 0) == 500), 177, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1) == 500), 177, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1, 2)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,))))) == 0), 177, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,))))) == 0), 177, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,))))) == 0), 177, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 2)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);
    int SAC_WL_MT_SCHEDULE_START( 1);
    int SAC_WL_MT_SCHEDULE_STOP( 1);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), 2)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 0);
    int SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), 2)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 0) = 1 * SAC_ND_A_SHAPE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1);
      SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 2, 0, 0, 500, 500)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 500;
    SAC_WL_MT_SCHEDULE_START( 1) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 1) = 500;

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), 2)
     */
    SAC_ND_WRITE( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 0)
      + SAC_WL_MT_SCHEDULE_START( 1) * SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP0_BEGIN( 1, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 1, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_INC_RC( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 1)
    /*
     * ND_ASSIGN( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), 0, (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), )

    SAC_ND_ALLOC_BEGIN( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2, (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2, (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))))"))
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,))))) == 0), 126, "1st argument of _idx_sel_ is not a scalar!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), 0), )

    SAC_ND_DEC_RC_FREE( (SACp_ive_10740__pinl_6905___iv, (SCL, (NHD, (NUQ,)))), 1, )
    /*
     * WL_ASSIGN( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), 2, (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,))))))), 126, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 1)), 126, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), (SACp_emal_10778__pinl_9996___flat_119__SSA10_1, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 1, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 1, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6905___iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    /*
     * MT_SCHEDULER_END( 0, 2, 0, 0, 500, 500)
     */


    /*
     * WL_SCHEDULE__END( 2)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_LABEL( _comp_10809_SAC_label)
  SAC_ND_FREE( (SACp_pinl_6909____nt2ot_302, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_6910____nt2ot_303, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_10738__pinl_6908___z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1, 2)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, 500, 500)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,))))) == 2), 110, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 0) == 500), 110, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1) == 500), 110, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1, 2)
  SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,))))) == 0), 110, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,))))) == 0), 110, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,))))) == 0), 110, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 2)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);
    int SAC_WL_MT_SCHEDULE_START( 1);
    int SAC_WL_MT_SCHEDULE_STOP( 1);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), 2)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 0);
    int SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), 2)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 0) = 1 * SAC_ND_A_SHAPE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1);
      SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 2, 0, 0, 500, 500)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 500;
    SAC_WL_MT_SCHEDULE_START( 1) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 1) = 500;

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), 2)
     */
    SAC_ND_WRITE( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 0)
      + SAC_WL_MT_SCHEDULE_START( 1) * SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP0_BEGIN( 1, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 1, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_INC_RC( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_ASSIGN( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), )

    SAC_PF_BEGIN_WITH( fold)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, 500)
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = 500;

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_NOOP( )
      SAC_ND_ALLOC_BEGIN( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_IDXS2OFFSET( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 2, (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 2, 500, 500)
       */
      SAC_ND_WRITE( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0) = ( 500 * SAC_ND_READ( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0) );

      SAC_ND_ALLOC_BEGIN( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_IDX_SEL__DATA( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))))"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "1st argument of _idx_sel_ is not a scalar!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_FREE( (SACp_emal_10775__ive_10741__pinl_6302___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_ALLOC_BEGIN( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_IDXS2OFFSET( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 2, (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 2, 500, 500)
       */
      SAC_ND_WRITE( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0) = ( 500 * SAC_ND_READ( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0) );

      SAC_ND_ALLOC_BEGIN( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_IDX_SEL__DATA( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))))"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "1st argument of _idx_sel_ is not a scalar!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_FREE( (SACp_emal_10773__ive_10742__pinl_6062___new_idx__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_PRF_SxS__DATA( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, SAC_ND_READ( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_emal_10772__pinl_6063____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_PRF_SxS__DATA( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 1, )
      /*
       * ND_ASSIGN( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), (SACp_emal_10774__pinl_6303____flat_119__SSA12_1__SSA14_1, (SCL, (NHD, (NUQ,)))), )

      /*
       * WL_FOLD( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))))
       */
      SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0)));
      /* fold operation */

      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_10589_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, 500)
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( fold)
    SAC_ND_LABEL( _comp_10810_SAC_label)
    SAC_ND_FREE( (SACp_pinl_10590__nt2ot_295, (SCL, (NHD, (NUQ,)))), )
    /*
     * WL_ASSIGN( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), 2, (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,))))))), 109, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 1)), 109, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), 0), (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_DEC_RC_FREE( (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_WL_INC_OFFSET( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6049___flat_100, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 1, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 1, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6034__iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    /*
     * MT_SCHEDULER_END( 0, 2, 0, 0, 500, 500)
     */


    /*
     * WL_SCHEDULE__END( 2)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_LABEL( _comp_10811_SAC_label)
  SAC_ND_FREE( (SACp_wlidx_10739__pinl_6014_TMP_33, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_10780__pinl_6012_m_0, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_10777__pinl_6908___z, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_nt2ot_10615, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_nt2ot_10616, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_ASSIGN( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), )

  SAC_PF_BEGIN_WITH( fold)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, 500)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 500;

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_INC_RC( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 1)
    SAC_NOOP( )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_ASSIGN( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), )

    SAC_PF_BEGIN_WITH( fold)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, 500)
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = 500;

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_NOOP( )
      SAC_ND_ALLOC_BEGIN( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_IDXS2OFFSET( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 2, (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 2, 500, 500)
       */
      SAC_ND_WRITE( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0) = ( 500 * SAC_ND_READ( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0) );

      SAC_ND_ALLOC_BEGIN( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_IDX_SEL__DATA( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), 2, (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))))"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "1st argument of _idx_sel_ is not a scalar!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_FREE( (SACp_emal_10768__ive_10743__pinl_10627__new_idx__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_PRF_SxS__DATA( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_DEC_RC_FREE( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, )
      /*
       * ND_ASSIGN( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10767__pinl_10628___flat_119__SSA15_1__SSA17_1, (SCL, (NHD, (NUQ,)))), )

      /*
       * WL_FOLD( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))))
       */
      SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0)));
      /* fold operation */

      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_10703_iv__SSA17_1, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, 500)
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( fold)
    SAC_ND_LABEL( _comp_10812_SAC_label)
    SAC_ND_FREE( (SACp_pinl_10704__nt2ot_295__SSA17_1, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_CHECK_REUSE( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    /*
     * ND_CHECK_REUSE( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_DEC_RC_FREE( (SACp_pinl_10622__flat_73__SSA17_1, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_DEC_RC_FREE( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 1, )
    /*
     * ND_ASSIGN( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), (SACp_emal_10765__pinl_10713____flat_53, (SCL, (NHD, (NUQ,)))), )

    /*
     * WL_FOLD( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))))
     */
    SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0)));
    /* fold operation */

    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_10710_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), 0, 500, 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, 500)
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( fold)
  SAC_ND_LABEL( _comp_10813_SAC_label)
  SAC_ND_FREE( (SACp_emal_10769__pinl_6014_TMP_33, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_DEC_RC_FREE( (SACp_emal_10788__pinl_7137___flat_177, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_FREE( (SACp_pinl_10711__nt2ot_295, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,))))) == 1), 90, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 0) == 1), 90, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0), )

  /*
   * ND_FUN_AP( ARRAYIO__PrintDoubleArray, , 4, inout_nodesc_bx, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), in_nodesc, (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))))
   */
  ARRAYIO__PrintDoubleArray( SAC_ND_ARG_inout_nodesc_bx( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,))))));

  SAC_ND_FREE( (SACp_emal_10764__pinl_7234__flat_103, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0), 1953127604156270080.0)
  /*
   * ND_ASSIGN( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,))))) == 0), 229, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6016_r_0, (SCL, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), (SACp_emal_10763__pinl_7265___flat_32, (SCL, (NHD, (NUQ,)))), )

  if (SACp_pinl_10806_____flat_187) 
  { 
    SAC_ND_DEC_RC_FREE( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_FREE( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,))))) == 0), 26, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_CREATE__SCALAR__DATA( (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), true)
    /*
     * ND_ASSIGN( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,))))) == 0), 26, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10799__emal_10753__pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), )

  }
  else
  { 
    SAC_ND_FREE( (SACp_pinl_10806_____flat_187, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_S__DATA( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_ABS, abs, SAC_ND_READ( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_MAX, max, SAC_ND_READ( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 0), 1953127604156270080.0)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, 1.0000000000000000303737455634003709136034716842278413651001756079494953155517578125e-13, SAC_ND_READ( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_CHECK_REUSE( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 0), 1953127604156270080.0)
    SAC_ND_DEC_RC_FREE( (SACp_pinl_10807____x, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_PRF_S__DATA( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), SAC_PRF_ABS, abs, SAC_ND_READ( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, SAC_ND_READ( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_FREE( (SACp_pinl_10805__emal_10759__pinl_10750____flat_46, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_10802__emal_10756__pinl_10747____flat_52, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,))))) == 0), 26, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), (SACp_pinl_10800__emal_10754__pinl_7264__hce_2__SSA18_1, (SCL, (NHD, (NUQ,)))), )

  }
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_COPY__DATA( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_7264__hce_2, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_PRF_SxS__DATA( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 1, SAC_ND_READ( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_ALLOC_BEGIN( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,))))) == 1), 96, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 0) == 1), 96, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))), 0), )

  /*
   * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), in_nodesc, (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))))
   */
  ARRAYIO__PrintIntArray( SAC_ND_ARG_inout_nodesc_bx( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,))))));

  SAC_ND_FREE( (SACp_emal_10760__pinl_7286__flat_102, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_10787__pinl_7122___iv__SSA4_1, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_10785__pinl_7105_____flat_54, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10762__pinl_7275___flat_11, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init()
{ 
  /*
   * ND_FUN_AP( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))))
   */
  SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_ARG_inout( (SACo_World__TheWorld, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))))
   */
  SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_ARG_inout( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))))
   */
  SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_ARG_inout( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_RET( , 0)
   */
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double))
{ 
  /*
   * ND_DECL( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_DECL__MIRROR_PARAM( (SACl_y, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_DECL__MIRROR_PARAM( (SACl_x, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_CHECK_REUSE( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACl_y, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  /*
   * ND_CHECK_REUSE( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACl_x, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
  SAC_ND_INC_RC( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACl_x, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACl_y, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_DEC_RC_FREE( (SACl_y, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_DEC_RC_FREE( (SACl_x, (SCL, (NHD, (NUQ,)))), 1, )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_10789__pinl_2516__flat_53, (SCL, (NHD, (NUQ,)))))
  return;
}

int main( int __argc, char *__argv[])
{
  SAC_ND_DECL__DATA( (SAC_res, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SAC_res, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()
  SAC_MT_SETUP_INITIAL();
  SAC_PF_SETUP();
  SAC_HM_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();
  SAC_COMMANDLINE_SET( __argc, __argv);

  SACf__MAIN__main( SAC_ND_ARG_out( (SAC_res, (SCL, (NHD, (NUQ,))))));

  SAC_PF_PRINT();
  SAC_CS_FINALIZE();
  SAC_HM_PRINT();

  return( SAC_ND_READ( (SAC_res, (SCL, (NHD, (NUQ,)))), 0));
}
