

/*
 *  Global Switches
 */

#define SAC_DO_CHECK           0
#define SAC_DO_CHECK_TYPE      0
#define SAC_DO_CHECK_BOUNDARY  0
#define SAC_DO_CHECK_MALLOC    0
#define SAC_DO_CHECK_ERRNO     0
#define SAC_DO_CHECK_HEAP      0

#define SAC_DO_PHM             1
#define SAC_DO_APS             1
#define SAC_DO_DAO             1
#define SAC_DO_MSCA            1

#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0

#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_AA        0
#define SAC_DO_TRACE_MT        0

#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_GLOBAL 1
#define SAC_DO_CACHESIM_FILE   0
#define SAC_DO_CACHESIM_PIPE   0
#define SAC_DO_CACHESIM_IMDT   1

#define SAC_DO_MULTITHREAD     0
#define SAC_DO_THREADS_STATIC  1

#define SAC_DO_COMPILE_MODULE  0



/*
 *  Global Settings
 */

#ifndef NULL
#define NULL                      (void*) 0
#endif

#define SAC_SET_INITIAL_MASTER_HEAPSIZE      1048576
#define SAC_SET_INITIAL_WORKER_HEAPSIZE      65536
#define SAC_SET_INITIAL_UNIFIED_HEAPSIZE     0

#ifndef SAC_SET_MTMODE
#define SAC_SET_MTMODE               0
#endif

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX          32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS              1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS          0
#endif

#define SAC_SET_MAX_SYNC_FOLD        0
#define SAC_SET_NUM_SCHEDULERS       0

#define SAC_SET_CACHE_1_SIZE         -1
#define SAC_SET_CACHE_1_LINE         4
#define SAC_SET_CACHE_1_ASSOC        1
#define SAC_SET_CACHE_1_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_1_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_2_SIZE         -1
#define SAC_SET_CACHE_2_LINE         4
#define SAC_SET_CACHE_2_ASSOC        1
#define SAC_SET_CACHE_2_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_2_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_3_SIZE         -1
#define SAC_SET_CACHE_3_LINE         4
#define SAC_SET_CACHE_3_ASSOC        1
#define SAC_SET_CACHE_3_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_3_MSCA_FACTOR  0.00

#define SAC_SET_CACHESIM_HOST        ""
#define SAC_SET_CACHESIM_FILE        "a.out.cs"
#define SAC_SET_CACHESIM_DIR         "/tmp"
#define SAC_SET_MAXFUN               0
#define SAC_SET_MAXFUNAP             1



/*
 *  Includes
 */


#include "sac.h"


/*
 *  SAC-Program tutu.sac :
 */


/*
 *  type definitions
 */

SAC_ND_TYPEDEF( (SACt_World__World, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_Terminal__Terminal, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_TermFile__TermFile, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_ComplexBasics__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_Complex__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_List__list, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_IOresources__TermFile, (SCL, (HID, (NUQ,)))), SACt_TermFile__TermFile)


/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()
SAC_HM_DEFINE()


/*
 *  prototypes for externals (FUNDECS)
 */

extern 
/*
 * ND_FUN_DEC( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SAC_hidden, (SACl_stream, (SCL, (HID, (NUQ,)))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, int, (SACl_a, (AUD, (NHD, (NUQ,)))))
 */
void ARRAYIO__PrintIntArray( SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ,)))), SAC_hidden), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), int));



/*
 *  prototypes for locals (FUNDEFS)
 */

extern 
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init();

extern 
/*
 * ND_FUN_DEC( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));



/*
 *  global objects
 */

/*
 * ND_OBJDEF_EXTERN( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()



/*
 *  function definitions (FUNDEFS)
 */

/* wrapper function */
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_cwc_138, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_cwc_138, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_cwc_138, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN__main, , 1, out, (SACp_cwc_138, (SCL, (NHD, (NUQ,)))))
   */
  SACf__MAIN__main( SAC_ND_ARG_out( (SACp_cwc_138, (SCL, (NHD, (NUQ,))))));

  /*
   * ND_REFRESH__MIRROR( (SACp_cwc_138, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOOP()

  SAC_ND_FREE( (SACp_cwc_138, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,))))) == 0), 46, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))), 0)
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_1370__cwc_137, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), int, 1, 20)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0) = 20;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))) = 20;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,))))) = 1;


  /*
   * ND_FUN_AP( SACf__MAIN_CL_INIT__init, , 0)
   */
  SACf__MAIN_CL_INIT__init();

  SAC_ND_ALLOC_BEGIN( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,))))) == 0), 211, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))), 0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, 20)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))) == 1), 29, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0) == 20), 29, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,))))) == 0), 29, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,))))) == 0), 29, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, 20)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 20;

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    SAC_ND_WRITE( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 3, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 17, SAC_ND_READ( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * WL_ASSIGN( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,))))))), 126, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0)), 126, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_1375__pinl_1353__uprf_1250__SSA4_1, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 3, 1)
    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 3, 20, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,))))) == 0), 127, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0), 3)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * WL_ASSIGN( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,))))))), 126, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), 0)), 126, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_1378__pinl_1355__uprf_1269__SSA4_2, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_1055_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), 3, 20, 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, 20)
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_LABEL( _comp_1381_SAC_label)
  SAC_ND_FREE( (SACp_wlidx_1369__pinl_1059_z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_1060__eat_117, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,))))) == 1), 42, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 0) == 1), 42, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 1, 1, 20, )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), 0, 20, )

  SAC_ND_ALLOC_BEGIN( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,))))) == 0), 23, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), 1)
  /*
   * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), in_nodesc, (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))))
   */
  ARRAYIO__PrintIntArray( SAC_ND_ARG_inout_nodesc_bx( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,))))));

  SAC_ND_FREE( (SACp_emal_1373__pinl_1059_z, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_1372__pinl_1106___flat_9, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_1371__pinl_1107___flat_8, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_1380__pinl_911__flat_3, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init()
{ 
  /*
   * ND_FUN_AP( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))))
   */
  SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_ARG_inout( (SACo_World__TheWorld, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))))
   */
  SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_ARG_inout( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))))
   */
  SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_ARG_inout( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_RET( , 0)
   */
  return;
}

int main( int __argc, char *__argv[])
{
  SAC_ND_DECL__DATA( (SAC_res, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SAC_res, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()
  SAC_MT_SETUP_INITIAL();
  SAC_PF_SETUP();
  SAC_HM_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();
  SAC_COMMANDLINE_SET( __argc, __argv);

  SACf__MAIN__main( SAC_ND_ARG_out( (SAC_res, (SCL, (NHD, (NUQ,))))));

  SAC_PF_PRINT();
  SAC_CS_FINALIZE();
  SAC_HM_PRINT();

  return( SAC_ND_READ( (SAC_res, (SCL, (NHD, (NUQ,)))), 0));
}
