

/*
 *  Global Switches
 */

#define SAC_DO_CHECK           0
#define SAC_DO_CHECK_TYPE      0
#define SAC_DO_CHECK_BOUNDARY  0
#define SAC_DO_CHECK_MALLOC    0
#define SAC_DO_CHECK_ERRNO     0
#define SAC_DO_CHECK_HEAP      0

#define SAC_DO_PHM             1
#define SAC_DO_APS             1
#define SAC_DO_DAO             1
#define SAC_DO_MSCA            1

#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0

#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_AA        0
#define SAC_DO_TRACE_MT        0

#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_GLOBAL 1
#define SAC_DO_CACHESIM_FILE   0
#define SAC_DO_CACHESIM_PIPE   0
#define SAC_DO_CACHESIM_IMDT   1

#define SAC_DO_MULTITHREAD     0
#define SAC_DO_THREADS_STATIC  1

#define SAC_DO_COMPILE_MODULE  0



/*
 *  Global Settings
 */

#ifndef NULL
#define NULL                      (void*) 0
#endif

#define SAC_SET_INITIAL_MASTER_HEAPSIZE      1048576
#define SAC_SET_INITIAL_WORKER_HEAPSIZE      65536
#define SAC_SET_INITIAL_UNIFIED_HEAPSIZE     0

#ifndef SAC_SET_MTMODE
#define SAC_SET_MTMODE               0
#endif

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX          32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS              1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS          0
#endif

#define SAC_SET_MAX_SYNC_FOLD        0
#define SAC_SET_NUM_SCHEDULERS       0

#define SAC_SET_CACHE_1_SIZE         -1
#define SAC_SET_CACHE_1_LINE         4
#define SAC_SET_CACHE_1_ASSOC        1
#define SAC_SET_CACHE_1_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_1_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_2_SIZE         -1
#define SAC_SET_CACHE_2_LINE         4
#define SAC_SET_CACHE_2_ASSOC        1
#define SAC_SET_CACHE_2_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_2_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_3_SIZE         -1
#define SAC_SET_CACHE_3_LINE         4
#define SAC_SET_CACHE_3_ASSOC        1
#define SAC_SET_CACHE_3_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_3_MSCA_FACTOR  0.00

#define SAC_SET_CACHESIM_HOST        ""
#define SAC_SET_CACHESIM_FILE        "logd.exe.cs"
#define SAC_SET_CACHESIM_DIR         "/tmp"
#define SAC_SET_MAXFUN               0
#define SAC_SET_MAXFUNAP             1



/*
 *  Includes
 */


#include "sac.h"


/*
 *  SAC-Program logd.sac :
 */


/*
 *  type definitions
 */

SAC_ND_TYPEDEF( (SACt_World__World, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_Terminal__Terminal, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_TermFile__TermFile, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_ComplexBasics__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_Complex__complex, (AKS, (NHD, (NUQ,)))), double)
SAC_ND_TYPEDEF( (SACt_List__list, (SCL, (HID, (NUQ,)))), SAC_hidden)
SAC_ND_TYPEDEF( (SACt_IOresources__TermFile, (SCL, (HID, (NUQ,)))), SACt_TermFile__TermFile)


/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()
SAC_HM_DEFINE()


/*
 *  prototypes for externals (FUNDECS)
 */

extern 
/*
 * ND_FUN_DEC( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, SAC_hidden, (SACl_stream, (SCL, (HID, (NUQ,)))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, int, (SACl_a, (AUD, (NHD, (NUQ,)))))
 */
void ARRAYIO__PrintIntArray( SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ,)))), SAC_hidden), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( ARRAYIO__PrintDoubleArray, , 4, inout_nodesc_bx, SAC_hidden, (SACl_stream, (SCL, (HID, (NUQ,)))), in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, double, (SACl_a, (AUD, (NHD, (NUQ,)))))
 */
void ARRAYIO__PrintDoubleArray( SAC_ND_PARAM_inout_nodesc_bx( (SACl_stream, (SCL, (HID, (NUQ,)))), SAC_hidden), SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), double));



/*
 *  prototypes for locals (FUNDEFS)
 */

extern 
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init();

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double));

extern 
/*
 * ND_FUN_DEC( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));

extern 
/*
 * ND_FUN_DEC( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, SAC_hidden, (SACp_OI_object, (SCL, (HID, (NUQ,)))))
 */
void SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_PARAM_inout( (SACp_OI_object, (SCL, (HID, (NUQ,)))), SAC_hidden));



/*
 *  global objects
 */

/*
 * ND_OBJDEF_EXTERN( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()

/*
 * ND_OBJDEF_EXTERN( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, 0)
 */
SAC_ND_DECL__DATA( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), SAC_hidden, extern)
SAC_ND_DECL__DESC( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), extern)
SAC_NOTHING()



/*
 *  function definitions (FUNDEFS)
 */

/* wrapper function */
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_cwc_385, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_cwc_385, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_cwc_385, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN__main, , 1, out, (SACp_cwc_385, (SCL, (NHD, (NUQ,)))))
   */
  SACf__MAIN__main( SAC_ND_ARG_out( (SACp_cwc_385, (SCL, (NHD, (NUQ,))))));

  /*
   * ND_REFRESH__MIRROR( (SACp_cwc_385, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOOP()

  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_385, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_385, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6540__emal_6441__pinl_6428____flat_49, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6540__emal_6441__pinl_6428____flat_49, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6540__emal_6441__pinl_6428____flat_49, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6539__emal_6440__pinl_6427____flat_51, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6539__emal_6440__pinl_6427____flat_51, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6539__emal_6440__pinl_6427____flat_51, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6537__emal_6438__pinl_6425____flat_46, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6537__emal_6438__pinl_6425____flat_46, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6537__emal_6438__pinl_6425____flat_46, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6510__emal_6433__pinl_4684____z__SSA7_4__SSA9_1__SSA10_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6510__emal_6433__pinl_4684____z__SSA7_4__SSA9_1__SSA10_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6510__emal_6433__pinl_4684____z__SSA7_4__SSA9_1__SSA10_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6488__emal_6435__pinl_4684____z__SSA7_4__SSA10_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6488__emal_6435__pinl_4684____z__SSA7_4__SSA10_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6488__emal_6435__pinl_4684____z__SSA7_4__SSA10_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), double, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN_CL_INIT__init, , 0)
   */
  SACf__MAIN_CL_INIT__init();

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,))))) == 0), 121, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), 0.0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,))))) == 1), 86, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 0) == 1), 86, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 1, 1, 1, )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), 0, 1, )

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,))))) == 0), 218, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,))))) == 0), 231, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 50.0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,))))) == 0), 231, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), -50.0)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,))))) == 0), 171, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_ASSIGN( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,))))) == 0), 171, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6480__pinl_5090___flat_111, (SCL, (NHD, (NUQ,)))), )

  SAC_PF_BEGIN_WITH( fold)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, 20000000)
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = 20000000;

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 19999999, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_NOOP( )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 127, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, 19999999, SAC_ND_READ( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 50, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 1, SAC_ND_READ( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5, SAC_ND_READ( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6474__uprf_6215__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5, SAC_ND_READ( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_FREE( (SACp_emal_6469__pinl_5109____flat_2__SSA5_2__SSA9_6, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6475__uprf_6183__SSA9_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5100000000000000088817841970012523233890533447265625, SAC_ND_READ( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), (SACp_emal_6464__pinl_4685______flat_32__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), (SACp_emal_6466__pinl_5109____flat_2__SSA5_1__SSA7_5__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6472__pinl_5109____flat_2__SSA5_2__SSA9_5, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6513_____flat_65) 
    { 
      SAC_ND_FREE( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 189, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
      SAC_ND_CREATE__SCALAR__DATA( (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 1.0)
      /*
       * ND_ASSIGN( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 188, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6509__emal_6432__pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_FREE( (SACp_pinl_6513_____flat_65, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_PRF_SxS__DATA( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, /, SAC_ND_READ( (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_pinl_6512____dy, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 188, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6511____dx, (SCL, (NHD, (NUQ,)))), )

    }
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, 50.0, SAC_ND_READ( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, 50.0, SAC_ND_READ( (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), (SACp_emal_6462__pinl_4597______flat_29__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), (SACp_pinl_4684____z__SSA7_4__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6519_____flat_61) 
    { 
      SAC_ND_INC_RC( (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_FREE( (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6517____cx, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_FREE( (SACp_pinl_6519_____flat_61, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6518____cy, (SCL, (NHD, (NUQ,)))), )

    }
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, -50.0, SAC_ND_READ( (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), (SACp_emal_6461__pinl_4553______flat_29__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,))))) == 0), 206, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), (SACp_pinl_4596____z__SSA7_2__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6525_____flat_60) 
    { 
      SAC_ND_FREE( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_INC_RC( (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6524____cy, (SCL, (NHD, (NUQ,)))), 1, )
      SAC_ND_FREE( (SACp_pinl_6525_____flat_60, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6523____cx, (SCL, (NHD, (NUQ,)))), )

    }
    /*
     * ND_CHECK_REUSE( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    /*
     * ND_CHECK_REUSE( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_DEC_RC_FREE( (SACp_pinl_4552____z__SSA7_1__SSA9_1, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_DEC_RC_FREE( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 1, )
    /*
     * ND_ASSIGN( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6460__pinl_4478_____flat_53__SSA9_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * WL_FOLD( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))))
     */
    SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0)));
    /* fold operation */

    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 19999999, 1)
    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 19999999, 20000000, 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_NOOP( )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,))))) == 0), 127, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, 19999999, SAC_ND_READ( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,))))) == 0), 50, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 1, SAC_ND_READ( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6458__uprf_6215__SSA7_5, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5, SAC_ND_READ( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,))))) == 0), 142, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6459__uprf_6183, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5100000000000000088817841970012523233890533447265625, SAC_ND_READ( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), (SACp_emal_6452__pinl_4685______flat_32__SSA7_4, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), (SACp_emal_6454__pinl_5109____flat_2__SSA5_1__SSA7_5, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6456__pinl_5109____flat_2__SSA5_2__SSA9_4, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6491_____flat_65) 
    { 
      SAC_ND_FREE( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,))))) == 0), 189, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 1, 0)
      SAC_ND_CREATE__SCALAR__DATA( (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 1.0)
      /*
       * ND_ASSIGN( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,))))) == 0), 188, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6487__emal_6434__pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_FREE( (SACp_pinl_6491_____flat_65, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_PRF_SxS__DATA( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, /, SAC_ND_READ( (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_pinl_6490____dy, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,))))) == 0), 188, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6489____dx, (SCL, (NHD, (NUQ,)))), )

    }
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, 50.0, SAC_ND_READ( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, 50.0, SAC_ND_READ( (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), (SACp_emal_6450__pinl_4597______flat_29__SSA7_2, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), (SACp_pinl_4684____z__SSA7_4, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6497_____flat_61) 
    { 
      SAC_ND_INC_RC( (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_FREE( (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_FREE( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6495____cx, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_FREE( (SACp_pinl_6497_____flat_61, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,))))) == 0), 202, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6496____cy, (SCL, (NHD, (NUQ,)))), )

    }
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, -50.0, SAC_ND_READ( (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_ASSIGN( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), (SACp_emal_6449__pinl_4553______flat_29__SSA7_1, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,))))) == 0), 206, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), (SACp_pinl_4596____z__SSA7_2, (SCL, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6503_____flat_60) 
    { 
      SAC_ND_FREE( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), )

    }
    else
    { 
      SAC_ND_INC_RC( (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6502____cy, (SCL, (NHD, (NUQ,)))), 1, )
      SAC_ND_FREE( (SACp_pinl_6503_____flat_60, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,))))) == 0), 213, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6501____cx, (SCL, (NHD, (NUQ,)))), )

    }
    /*
     * ND_CHECK_REUSE( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    /*
     * ND_CHECK_REUSE( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_DEC_RC_FREE( (SACp_pinl_4552____z__SSA7_1, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_DEC_RC_FREE( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 1, )
    /*
     * ND_ASSIGN( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6448__pinl_4478_____flat_53, (SCL, (NHD, (NUQ,)))), )

    /*
     * WL_FOLD( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))))
     */
    SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0)));
    /* fold operation */

    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_4463__iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), 19999999, 20000000, 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, 20000000)
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( fold)
  SAC_ND_LABEL( _comp_6544_SAC_label)
  SAC_ND_FREE( (SACp_pinl_4468___eat_279, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6476__pinl_4549____cx, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6477__pinl_4637_____flat_63, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,))))) == 1), 152, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 0) == 1), 152, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0), )

  /*
   * ND_FUN_AP( ARRAYIO__PrintDoubleArray, , 4, inout_nodesc_bx, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), in_nodesc, (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))))
   */
  ARRAYIO__PrintDoubleArray( SAC_ND_ARG_inout_nodesc_bx( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,))))));

  SAC_ND_FREE( (SACp_emal_6447__pinl_5176__flat_90, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0), 887.291909965962759088142774999141693115234375)
  /*
   * ND_ASSIGN( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,))))) == 0), 172, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), (SACp_pinl_4467__z, (SCL, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), (SACp_emal_6446__pinl_5207___flat_32, (SCL, (NHD, (NUQ,)))), )

  if (SACp_pinl_6542_____flat_173) 
  { 
    SAC_ND_DEC_RC_FREE( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_FREE( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,))))) == 0), 22, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_CREATE__SCALAR__DATA( (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), true)
    /*
     * ND_ASSIGN( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,))))) == 0), 22, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6535__emal_6436__pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), )

  }
  else
  { 
    SAC_ND_FREE( (SACp_pinl_6542_____flat_173, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_S__DATA( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_ABS, abs, SAC_ND_READ( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_MAX, max, SAC_ND_READ( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 0), 887.291909965962759088142774999141693115234375)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, 1.0000000000000000303737455634003709136034716842278413651001756079494953155517578125e-13, SAC_ND_READ( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * ND_CHECK_REUSE( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, -, SAC_ND_READ( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 0), 887.291909965962759088142774999141693115234375)
    SAC_ND_DEC_RC_FREE( (SACp_pinl_6543____x, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_PRF_S__DATA( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), SAC_PRF_ABS, abs, SAC_ND_READ( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, SAC_ND_READ( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_FREE( (SACp_pinl_6541__emal_6442__pinl_6429____flat_46, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6538__emal_6439__pinl_6426____flat_52, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,))))) == 0), 22, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6536__emal_6437__pinl_5206__hce_1__SSA10_1, (SCL, (NHD, (NUQ,)))), )

  }
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,))))) == 0), 131, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_COPY__DATA( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5206__hce_1, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 1, SAC_ND_READ( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,))))) == 1), 158, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 0) == 1), 158, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))), 0), )

  /*
   * ND_FUN_AP( ARRAYIO__PrintIntArray, , 4, inout_nodesc_bx, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))), in_nodesc, (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), in_nodesc, (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))))
   */
  ARRAYIO__PrintIntArray( SAC_ND_ARG_inout_nodesc_bx( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,))))), SAC_ND_ARG_in_nodesc( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,))))));

  SAC_ND_FREE( (SACp_emal_6443__pinl_5228__flat_89, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6479__pinl_5024____offset, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6478__pinl_6353__count__SSA0_3, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6445__pinl_5217___flat_11, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN_CL_INIT__init, , 0)
 */
void SACf__MAIN_CL_INIT__init()
{ 
  /*
   * ND_FUN_AP( SACf_World_CL_INIT__init_TheWorld__SACt_World__World, , 1, inout, (SACo_World__TheWorld, (SCL, (HID, (NUQ,)))))
   */
  SACf_World_CL_INIT__init_TheWorld__SACt_World__World( SAC_ND_ARG_inout( (SACo_World__TheWorld, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal, , 1, inout, (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,)))))
   */
  SACf_Terminal_CL_INIT__init_TheTerminal__SACt_Terminal__Terminal( SAC_ND_ARG_inout( (SACo_Terminal__TheTerminal, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_AP( SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile, , 1, inout, (SACo_TermFile__stdout, (SCL, (HID, (NUQ,)))))
   */
  SACf_TermFile_CL_INIT__init_stdout__SACt_TermFile__TermFile( SAC_ND_ARG_inout( (SACo_TermFile__stdout, (SCL, (HID, (NUQ,))))));

  /*
   * ND_FUN_RET( , 0)
   */
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double))
{ 
  /*
   * ND_DECL( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_DECL__MIRROR_PARAM( (SACl_y, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_DECL__MIRROR_PARAM( (SACl_x, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_CHECK_REUSE( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACl_y, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  /*
   * ND_CHECK_REUSE( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 0, (SACl_x, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 0, 0)
  SAC_ND_INC_RC( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACl_x, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACl_y, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_DEC_RC_FREE( (SACl_y, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_DEC_RC_FREE( (SACl_x, (SCL, (NHD, (NUQ,)))), 1, )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6481__pinl_2289__flat_53, (SCL, (NHD, (NUQ,)))))
  return;
}

int main( int __argc, char *__argv[])
{
  SAC_ND_DECL__DATA( (SAC_res, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SAC_res, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()
  SAC_MT_SETUP_INITIAL();
  SAC_PF_SETUP();
  SAC_HM_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();
  SAC_COMMANDLINE_SET( __argc, __argv);

  SACf__MAIN__main( SAC_ND_ARG_out( (SAC_res, (SCL, (NHD, (NUQ,))))));

  SAC_PF_PRINT();
  SAC_CS_FINALIZE();
  SAC_HM_PRINT();

  return( SAC_ND_READ( (SAC_res, (SCL, (NHD, (NUQ,)))), 0));
}
