/*
 *  Target Platform
 */

#define SAC_FOR_LINUX_X86


/*
 *  Global Switches
 */

#define SAC_DO_MALLOCCHECK     0
#define SAC_DO_BOUNDCHECK      0
#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0
#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_OWL       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_MT        0
#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_PRAGMA 0

#ifndef SAC_DO_MULTITHREAD
#define SAC_DO_MULTITHREAD     0
#endif

#ifndef SAC_DO_THREADS_STATIC
#define SAC_DO_THREADS_STATIC  1
#endif


/*
 *  Global Settings
 */

#define NULL                      (void*) 0

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX       32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS           1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS       0
#endif

#define SAC_SET_MAX_SYNC_FOLD     3

#define SAC_SET_CACHE_1_SIZE      0
#define SAC_SET_CACHE_1_LINE      0
#define SAC_SET_CACHE_1_ASSOC     0
#define SAC_SET_CACHE_1_WRITEPOL  SAC_CS_default

#define SAC_SET_CACHE_2_SIZE      0
#define SAC_SET_CACHE_2_LINE      0
#define SAC_SET_CACHE_2_ASSOC     0
#define SAC_SET_CACHE_2_WRITEPOL  SAC_CS_default

#define SAC_SET_CACHE_3_SIZE      0
#define SAC_SET_CACHE_3_LINE      0
#define SAC_SET_CACHE_3_ASSOC     0
#define SAC_SET_CACHE_3_WRITEPOL  SAC_CS_default

#define SAC_SET_MAXFUN            1
#define SAC_SET_MAXFUNAP          1

#define SAC_SET_FUN_NAMES    \
  {    \
    "main"   \
  }

#define SAC_SET_FUN_APPS    \
  {    \
    1   \
  }

#define SAC_SET_FUN_AP_LINES    \
  {    \
    {    \
      0   \
    }   \
  }


/*
 *  Includes
 */


#include "sac.h"



/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()

/*
 *  SAC-Program logd3.sac :
 */


/*
 *  type definitions
 */

SAC_ND_TYPEDEF_ARRAY(double, SACt_Complex__complex)
typedef void * list;

extern void *copy_list(void *);
extern void free_list(void *);

typedef void * Terminal;
typedef void * TermFile;
typedef int syserr;
typedef void * string;

extern void *copy_string(void *);
extern void free(void *);

typedef void * FileSystem;
typedef void * World;
typedef void * File;


/*
 *  function declarations
 */

extern 
/*
 * ND_FUN_DEC( create_TheWorld, void *, 0)
 */
void * create_TheWorld( );
extern 
/*
 * ND_FUN_DEC( create_TheFileSystem, void *, 0)
 */
void * create_TheFileSystem( );
extern 
/*
 * ND_FUN_DEC( create_stderr, void *, 0)
 */
void * create_stderr( );
extern 
/*
 * ND_FUN_DEC( create_stdout, void *, 0)
 */
void * create_stdout( );
extern 
/*
 * ND_FUN_DEC( create_stdin, void *, 0)
 */
void * create_stdin( );
extern 
/*
 * ND_FUN_DEC( create_TheTerminal, void *, 0)
 */
void * create_TheTerminal( );
extern 
/*
 * ND_FUN_DEC( printf, void, 2, in, void *, SACl_FORMAT, in, ..., )
 */
void printf(  void * SACl_FORMAT, ... );
extern 
/*
 * ND_FUN_DEC( SACf_plusreduce__d_500000_, double, 1, in_rc, double *, SACl_n)
 */
double SACf_plusreduce__d_500000_(  SAC_ND_KS_DEC_IN_RC(double *, SACl_n));
extern 
/*
 * ND_FUN_DEC( SACf_logd3__d_500000_, void, 2, out_rc, double *, SACl_res, in_rc, double *, SACl_a)
 */
void SACf_logd3__d_500000_(  SAC_ND_KS_DEC_OUT_RC(double *, SACl_res), SAC_ND_KS_DEC_IN_RC(double *, SACl_a));
extern 
/*
 * ND_FUN_DEC( to_string, void, 3, out_rc, void *, , in_rc, char *, SACl_A, in, int, SACl_LENGTH)
 */
void to_string( SAC_ND_KS_DEC_IMPORT_OUT_RC(void *), SAC_ND_KS_DEC_IN_RC(char *, SACl_A), int SACl_LENGTH);


/*
 *  global objects
 */

extern World TheWorld;
extern Terminal TheTerminal;
extern TermFile SACstdin;
extern TermFile SACstdout;
extern TermFile SACstderr;
extern FileSystem TheFileSystem;


/*
 *  function definitions
 */


/*
 * ND_FUN_DEC( SACf_plusreduce__d_500000_, double, 1, in_rc, double *, SACl_n)
 */
double SACf_plusreduce__d_500000_(  SAC_ND_KS_DEC_IN_RC(double *, SACl_n))
{ 
  double SACp_flat_0;
  double SACp_flat_7;
  int SACp_type_44;
  
  /*
   * ND_KS_DECL_ARRAY( int, SACp_flat_6_i, 1, 1)
   */
  int *SACp_flat_6_i;
  int SAC_ND_A_RC(SACp_flat_6_i);
  int SAC_ND_A_SIZE(SACp_flat_6_i)=1;
  int SAC_ND_A_DIM(SACp_flat_6_i)=1;
  int SAC_ND_KD_A_SHAPE(SACp_flat_6_i, 0)=1;


  int SACp_flat_6_i_500000__;


  
  /*
   * ND_KS_DECL_ARRAY_ARG( SACl_n, 1, 500000)
   */
  int SAC_ND_A_SIZE(SACl_n)=500000;
  int SAC_ND_A_DIM(SACl_n)=1;
  int SAC_ND_KD_A_SHAPE(SACl_n, 0)=500000;


  SAC_ND_ALLOC_ARRAY(int, SACp_flat_6_i, 1)
  SACp_flat_0 = 0.0; 
  SAC_PF_BEGIN_WITH(fold)
  
  /*
   * WL_FOLD_BEGIN( SACp_flat_0, SACp_flat_6_i, 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START(0);
    int SAC_WL_MT_SCHEDULE_STOP(0);


      
      /*
       * MT_SCHEDULER_BEGIN( 1, 0, 500000)
       */
      SAC_WL_MT_SCHEDULE_START(0) = 0;
      SAC_WL_MT_SCHEDULE_STOP(0) = 500000;

        SAC_WL_STRIDE_LOOP0_BEGIN(0, SACp_flat_6_i, SACp_type_44, 0, 500000, 1)
          SAC_WL_GRID_UNROLL_BEGIN(0, SACp_flat_6_i, SACp_type_44, 0, 1)
            SAC_WL_GRID_SET_IDX(0, SACp_flat_6_i, SACp_type_44, 0, 1)
            
            /*
             * ND_KS_VECT2OFFSET( SACp_flat_6_i_500000__, SACp_flat_6_i, 1, 1, 500000)
             */
            SACp_flat_6_i_500000__ = SAC_ND_READ_ARRAY(SACp_flat_6_i, 0);

            SAC_ND_IDX_PSI_S(SACp_flat_6_i_500000__, SACl_n, SACp_flat_7)
            SACp_flat_0 = (SACp_flat_0 + SACp_flat_7); 
          SAC_WL_GRID_UNROLL_END(0, SACp_flat_6_i, SACp_type_44, 0, 1)
        SAC_WL_STRIDE_LOOP_END(0, SACp_flat_6_i, SACp_type_44, 0, 500000, 1)
      
      /*
       * MT_SCHEDULER_END( 1, 0, 500000)
       */


      SAC_PF_END_WITH(fold)
    
    /*
     * WL_FOLD_END( SACp_flat_0, SACp_flat_6_i, 1)
     */
}

  SAC_ND_DEC_RC_FREE_ARRAY(SACl_n, 1)
  SAC_ND_DEC_RC_FREE_ARRAY(SACp_flat_6_i, 1)
  
  /*
   * ND_FUN_RET( SACp_flat_0, 0)
   */
  return(SACp_flat_0);
}


/*
 * ND_FUN_DEC( SACf_logd3__d_500000_, void, 2, out_rc, double *, SACl_res, in_rc, double *, SACl_a)
 */
void SACf_logd3__d_500000_(  SAC_ND_KS_DEC_OUT_RC(double *, SACl_res), SAC_ND_KS_DEC_IN_RC(double *, SACl_a))
{ 
  
  /*
   * ND_KS_DECL_ARRAY( int, SACp__inl7__flat_270_iv, 1, 1)
   */
  int *SACp__inl7__flat_270_iv;
  int SAC_ND_A_RC(SACp__inl7__flat_270_iv);
  int SAC_ND_A_SIZE(SACp__inl7__flat_270_iv)=1;
  int SAC_ND_A_DIM(SACp__inl7__flat_270_iv)=1;
  int SAC_ND_KD_A_SHAPE(SACp__inl7__flat_270_iv, 0)=1;


  int SACp__inl7__flat_270_iv_500000__;
  double SACp__inl7__flat_271;
  
  /*
   * ND_KS_DECL_ARRAY( double, SACp__inl7_result, 1, 500000)
   */
  double *SACp__inl7_result;
  int SAC_ND_A_RC(SACp__inl7_result);
  int SAC_ND_A_SIZE(SACp__inl7_result)=500000;
  int SAC_ND_A_DIM(SACp__inl7_result)=1;
  int SAC_ND_KD_A_SHAPE(SACp__inl7_result, 0)=500000;


  int SACp__inl7__type_43;
  double SACp__inl6__flat_253;
  double SACp__inl5__flat_20;
  double SACp__inl4__flat_23;
  double SACp__inl3__flat_16;
  
  /*
   * ND_KS_DECL_ARRAY( int, SACp__inl2__flat_11, 1, 1)
   */
  int *SACp__inl2__flat_11;
  int SAC_ND_A_RC(SACp__inl2__flat_11);
  int SAC_ND_A_SIZE(SACp__inl2__flat_11)=1;
  int SAC_ND_A_DIM(SACp__inl2__flat_11)=1;
  int SAC_ND_KD_A_SHAPE(SACp__inl2__flat_11, 0)=1;


  int SACp__inl2__flat_11_500000__;
  double SACp__inl2__flat_10;
  double SACp__inl0__flat_28;
  double SACp__inl0__flat_27;
  
  /*
   * ND_KS_DECL_ARRAY( double, SACl_res, 1, 500000)
   */
  double *SACl_res;
  int SAC_ND_A_RC(SACl_res);
  int SAC_ND_A_SIZE(SACl_res)=500000;
  int SAC_ND_A_DIM(SACl_res)=1;
  int SAC_ND_KD_A_SHAPE(SACl_res, 0)=500000;



  
  /*
   * ND_KS_DECL_ARRAY_ARG( SACl_a, 1, 500000)
   */
  int SAC_ND_A_SIZE(SACl_a)=500000;
  int SAC_ND_A_DIM(SACl_a)=1;
  int SAC_ND_KD_A_SHAPE(SACl_a, 0)=500000;


  SAC_ND_ALLOC_ARRAY(double, SACp__inl7_result, 0)
  SAC_ND_INC_RC(SACp__inl7_result, 1)
  SAC_PF_BEGIN_WITH(genarray)
  
  /*
   * WL_NONFOLD_BEGIN( SACp__inl7_result, SACp__inl7__flat_270_iv, 1)
   */
  {
    int SACp__inl7_result__destptr;
    int SAC_WL_MT_SCHEDULE_START(0);
    int SAC_WL_MT_SCHEDULE_STOP(0);


      
      /*
       * MT_SCHEDULER_BEGIN( 1, 0, 500000)
       */
      SAC_WL_MT_SCHEDULE_START(0) = 0;
      SAC_WL_MT_SCHEDULE_STOP(0) = 500000;

        
        /*
         * WL_INIT_OFFSET( 1, SACp__inl7_result, SACp__inl7__flat_270_iv, 1)
         */
        SACp__inl7_result__destptr = 
          SAC_WL_MT_SCHEDULE_START(0)
          ;

        SAC_WL_STRIDE_LOOP0_BEGIN(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1, 1)
          SAC_WL_GRID_UNROLL_BEGIN(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1)
            SAC_ND_KS_USE_GENVAR_OFFSET(SACp__inl7__flat_270_iv_500000__, SACp__inl7_result)
            SAC_ND_IDX_PSI_S(SACp__inl7__flat_270_iv_500000__, SACl_a, SACp__inl0__flat_28)
            SACp__inl0__flat_27 = (0.01000000000000000020816681711721685132943093776702880859375 + SACp__inl0__flat_28); 
            SACp__inl4__flat_23 = (SACp__inl0__flat_28 / SACp__inl0__flat_27); 
            SACp__inl5__flat_20 = (50.0 * SACp__inl4__flat_23); 
            SACp__inl6__flat_253 =             SAC_ND_MIN(50.0, SACp__inl5__flat_20); 
            SACp__inl7__flat_271 =             SAC_ND_MAX(-50.0, SACp__inl6__flat_253); 
            
            /*
             * WL_ASSIGN( 0, SACp__inl7__flat_271, 1, SACp__inl7_result, SACp__inl7__flat_270_iv, 1, SACp__inl7__type_43)
             */
            SAC_TR_WL_PRINT(("Array element SACp__inl7_result[[%d]] at offset %d set.", SACp__inl7__type_43, SACp__inl7_result__destptr));
            SAC_ND_WRITE_ARRAY( SACp__inl7_result, SACp__inl7_result__destptr) = SACp__inl7__flat_271;
            SACp__inl7_result__destptr++;

          SAC_WL_GRID_UNROLL_END(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1)
        SAC_WL_STRIDE_LOOP_END(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1, 1)
        SAC_WL_STRIDE_LOOP0_BEGIN(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 1, 500000, 1)
          SAC_WL_GRID_UNROLL_BEGIN(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1)
            SAC_ND_KS_USE_GENVAR_OFFSET(SACp__inl7__flat_270_iv_500000__, SACp__inl7_result)
            SAC_ND_IDX_PSI_S(SACp__inl7__flat_270_iv_500000__, SACl_a, SACp__inl0__flat_28)
            SACp__inl0__flat_27 = (0.01000000000000000020816681711721685132943093776702880859375 + SACp__inl0__flat_28); 
            SACp__inl2__flat_11_500000__ = (SACp__inl7__flat_270_iv_500000__ - 1); 
            SAC_ND_IDX_PSI_S(SACp__inl2__flat_11_500000__, SACl_a, SACp__inl2__flat_10)
            SACp__inl3__flat_16 = (SACp__inl0__flat_28 - SACp__inl2__flat_10); 
            SACp__inl4__flat_23 = (SACp__inl3__flat_16 / SACp__inl0__flat_27); 
            SACp__inl5__flat_20 = (50.0 * SACp__inl4__flat_23); 
            SACp__inl6__flat_253 =             SAC_ND_MIN(50.0, SACp__inl5__flat_20); 
            SACp__inl7__flat_271 =             SAC_ND_MAX(-50.0, SACp__inl6__flat_253); 
            
            /*
             * WL_ASSIGN( 0, SACp__inl7__flat_271, 1, SACp__inl7_result, SACp__inl7__flat_270_iv, 1, SACp__inl7__type_43)
             */
            SAC_TR_WL_PRINT(("Array element SACp__inl7_result[[%d]] at offset %d set.", SACp__inl7__type_43, SACp__inl7_result__destptr));
            SAC_ND_WRITE_ARRAY( SACp__inl7_result, SACp__inl7_result__destptr) = SACp__inl7__flat_271;
            SACp__inl7_result__destptr++;

          SAC_WL_GRID_UNROLL_END(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 0, 1)
        SAC_WL_STRIDE_LOOP_END(0, SACp__inl7__flat_270_iv, SACp__inl7__type_43, 1, 500000, 1)
      
      /*
       * MT_SCHEDULER_END( 1, 0, 500000)
       */


      SAC_PF_END_WITH(genarray)
    
    /*
     * WL_NONFOLD_END( SACp__inl7_result, SACp__inl7__flat_270_iv, 1)
     */
}

  SAC_ND_DEC_RC_FREE_ARRAY(SACl_a, 1)
  SAC_ND_KS_ASSIGN_ARRAY(SACp__inl7_result, SACl_res)
  
  /*
   * ND_FUN_RET( , 1, out_rc, SACl_res)
   */
  SAC_ND_KS_RET_OUT_RC(SACl_res);
  
}


/*
 * ND_FUN_DEC( main, int, 0)
 */
int main( int __argc, char *__argv[])
{ 
  int SACp_flat_35;
  SAC_ND_DECL_RC(void*, SACp_flat_33)
  
  /*
   * ND_KS_DECL_ARRAY( char, SACp_flat_34, 1, 12)
   */
  char *SACp_flat_34;
  int SAC_ND_A_RC(SACp_flat_34);
  int SAC_ND_A_SIZE(SACp_flat_34)=12;
  int SAC_ND_A_DIM(SACp_flat_34)=1;
  int SAC_ND_KD_A_SHAPE(SACp_flat_34, 0)=12;


  double SACl_res;
  
  /*
   * ND_KS_DECL_ARRAY( double, SACp_flat_32, 1, 500000)
   */
  double *SACp_flat_32;
  int SAC_ND_A_RC(SACp_flat_32);
  int SAC_ND_A_SIZE(SACp_flat_32)=500000;
  int SAC_ND_A_DIM(SACp_flat_32)=1;
  int SAC_ND_KD_A_SHAPE(SACp_flat_32, 0)=500000;


  
  /*
   * ND_KS_DECL_ARRAY( double, SACl_a, 1, 500000)
   */
  double *SACl_a;
  int SAC_ND_A_RC(SACl_a);
  int SAC_ND_A_SIZE(SACl_a)=500000;
  int SAC_ND_A_DIM(SACl_a)=1;
  int SAC_ND_KD_A_SHAPE(SACl_a, 0)=500000;


  double SACp_flat_30;
  int SACp_type_36;
  
  /*
   * ND_KS_DECL_ARRAY( int, SACp_flat_29_iv, 1, 1)
   */
  int *SACp_flat_29_iv;
  int SAC_ND_A_RC(SACp_flat_29_iv);
  int SAC_ND_A_SIZE(SACp_flat_29_iv)=1;
  int SAC_ND_A_DIM(SACp_flat_29_iv)=1;
  int SAC_ND_KD_A_SHAPE(SACp_flat_29_iv, 0)=1;



  SAC_PF_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();

  
  /*
   * ND_FUN_AP( create_TheWorld, TheWorld, 0)
   */
  TheWorld =create_TheWorld( );
  
  /*
   * ND_FUN_AP( create_TheTerminal, TheTerminal, 0)
   */
  TheTerminal =create_TheTerminal( );
  
  /*
   * ND_FUN_AP( create_stdin, SACstdin, 0)
   */
  SACstdin =create_stdin( );
  
  /*
   * ND_FUN_AP( create_stdout, SACstdout, 0)
   */
  SACstdout =create_stdout( );
  
  /*
   * ND_FUN_AP( create_stderr, SACstderr, 0)
   */
  SACstderr =create_stderr( );
  
  /*
   * ND_FUN_AP( create_TheFileSystem, TheFileSystem, 0)
   */
  TheFileSystem =create_TheFileSystem( );
  SAC_ND_ALLOC_ARRAY(double, SACl_a, 0)
  SAC_ND_INC_RC(SACl_a, 1)
  SAC_PF_BEGIN_WITH(genarray)
  
  /*
   * WL_NONFOLD_BEGIN( SACl_a, SACp_flat_29_iv, 1)
   */
  {
    int SACl_a__destptr;
    int SAC_WL_MT_SCHEDULE_START(0);
    int SAC_WL_MT_SCHEDULE_STOP(0);


      
      /*
       * MT_SCHEDULER_BEGIN( 1, 0, 500000)
       */
      SAC_WL_MT_SCHEDULE_START(0) = 0;
      SAC_WL_MT_SCHEDULE_STOP(0) = 500000;

        
        /*
         * WL_INIT_OFFSET( 1, SACl_a, SACp_flat_29_iv, 1)
         */
        SACl_a__destptr = 
          SAC_WL_MT_SCHEDULE_START(0)
          ;

        SAC_WL_STRIDE_LOOP0_BEGIN(0, SACp_flat_29_iv, SACp_type_36, 0, 500000, 1)
          SAC_WL_GRID_UNROLL_BEGIN(0, SACp_flat_29_iv, SACp_type_36, 0, 1)
            SACp_flat_30 = (0.5 + SACp_type_36); 
            
            /*
             * WL_ASSIGN( 0, SACp_flat_30, 1, SACl_a, SACp_flat_29_iv, 1, SACp_type_36)
             */
            SAC_TR_WL_PRINT(("Array element SACl_a[[%d]] at offset %d set.", SACp_type_36, SACl_a__destptr));
            SAC_ND_WRITE_ARRAY( SACl_a, SACl_a__destptr) = SACp_flat_30;
            SACl_a__destptr++;

          SAC_WL_GRID_UNROLL_END(0, SACp_flat_29_iv, SACp_type_36, 0, 1)
        SAC_WL_STRIDE_LOOP_END(0, SACp_flat_29_iv, SACp_type_36, 0, 500000, 1)
      
      /*
       * MT_SCHEDULER_END( 1, 0, 500000)
       */


      SAC_PF_END_WITH(genarray)
    
    /*
     * WL_NONFOLD_END( SACl_a, SACp_flat_29_iv, 1)
     */
}

  
  /*
   * ND_FUN_AP( SACf_logd3__d_500000_, , 2, out_rc, SACp_flat_32, in_rc, SACl_a)
   */
  SACf_logd3__d_500000_(  SAC_ND_KS_AP_OUT_RC(SACp_flat_32), SAC_ND_KS_AP_IN_RC(SACl_a));
  
  /*
   * ND_FUN_AP( SACf_plusreduce__d_500000_, SACl_res, 1, in_rc, SACp_flat_32)
   */
  SACl_res =SACf_plusreduce__d_500000_(  SAC_ND_KS_AP_IN_RC(SACp_flat_32));
  SAC_ND_ALLOC_ARRAY(char, SACp_flat_34, 1)
  SAC_ND_CREATE_CONST_ARRAY_C(SACp_flat_34, "result: %f\n")
  
  /*
   * ND_FUN_AP( to_string, , 3, out_rc, SACp_flat_33, in_rc, SACp_flat_34, in, 11)
   */
  to_string(  SAC_ND_KS_AP_OUT_RC(SACp_flat_33), SAC_ND_KS_AP_IN_RC(SACp_flat_34), 11);
  
  /*
   * ND_FUN_AP( printf, , 2, in, SACp_flat_33, in, SACl_res)
   */
  printf(  SACp_flat_33, SACl_res);
  SAC_ND_DEC_RC_FREE_HIDDEN(SACp_flat_33, 1, free)
  SACp_flat_35 = 0; 
  
  /*
   * ND_FUN_RET( SACp_flat_35, 0)
   */
  
  SAC_PF_PRINT();
  SAC_CS_FINALIZE();

  return(SACp_flat_35);
}
