% SAC Code fragments for outer product loop control.
% Robert Bernecky 2005-11-05

%Fragment  jotdot 000 bidc bidc bidc .
inline $ZTYPE $FNAME($XTYPE x, $YTYPE y$SYSVARFGDECL)
{ /* SxS outer product */
  z = $FN$CT$CT$ZT(to$CT(x),to$CT(y)$SYSVARGKER);
  return(z);
}
%Generate , $FN, $CT$CT$ZT, 000, ., $CT

%Fragment  jotdot 0** bidc bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE x, $YTYPE[+] y$SYSVARFGDECL)
{ /* SxA outer product */
  z = $FN$CT$CT$ZT(to$CT(x),to$CT(y)$SYSVARGKER);
  return(z);
}
%Generate , $FN, $CT$CT$ZT, 0**, ., $CT

%Fragment  jotdot *0* bidc bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE [+] x, $YTYPE y$SYSVARFGDECL)
{ /* AxS outer product */
  z = $FN$CT$CT$ZT(to$CT(x),to$CT(y)$SYSVARGKER);
  return(z);
}
%Generate , $FN, $CT$CT$ZT, *0*, ., $CT

%Fragment  jotdot *** bidc bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE [+] x, $YTYPE [+] y$SYSVARFGDECL)
{ /* AxA outer product */
 cell = genarray(shape(y), $OTFILL);
 z = with {
	(. <= iv <= .) {
	 xitem = to$CT(x[iv]);
	} : $FN$CT$CT$ZT(xitem, to$CT(y)$SYSVARGKER);
	} : genarray(shape(x), cell);
 return(z);
}
%Generate , $FN, $CT$CT$ZT, 0**, ., $CT
%
% Copyright (C) 2007 Robert Bernecky
%   This file is part of the APEX APL compiler run-time system.
%
%   The APEX APL compiler run-time system is free software; 
%   you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation; either
%   version 2.1 of the License, or (at your option) any later version.
%
%   The APEX APL compiler run-time system is distributed in the 
%   hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with the GNU C Library; if not, write to the Free
%   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
%   02111-1307 USA.  
%
