% SAC Code fragments for rank conjunctions
% Robert Bernecky 2006-08-17

%Fragment nuax x00 x bidc bidc .
inline $ZTYPE $FNAME($YTYPE y$SYSVARFGDECL)
{ /* S monadic rank conj */ 
  z =  $FN$XT$YT$ZT(y$SYSVARGKER);
  return(z);
} 
%Generate , $FN, X$YT$ZT, X00, ., $CT

%Fragment nuax x** x bidc bidc EXTY
inline $ZTYPE[*] $FNAMEEXTY($YTYPE[+] y$SYSVARFGDECL)
{ /* Monadic rank conjunction on non-scalar. Extend right argument */
 yframeshape = drop([-$YRANK], shape(y));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FNX$YT$ZT(x[iv], y$SYSVARGKER);
	} : genarray(yframeshape, defcell);
  return(z);
} 
%Generate , $FN, X$YT$ZT, X$YRANK*, ., $CT

%Fragment nuax 000 bidc bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE x, $YTYPE y$SYSVARFGDECL)
{ /* SxS dyadic rank conj */ 
  z =  $FN$XT$YT$ZT(x,y$SYSVARGKER);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, 000, ., $CT

%Fragment nuax 0** bidc bidc bidc EXTX
inline $ZTYPE[*] $FNAMEEXTX($XTYPE x, $YTYPE[+] y$SYSVARFGDECL)
{ /* SxA rank conjunction. Extend left argument */ 
 yframeshape = drop([-$YRANK], shape(y));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FN$XT$YT$ZT(x, y[iv]$SYSVARGKER);
	} : genarray(yframeshape, defcell);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, $XRANK$YRANK*, ., $CT

%Fragment nuax *0* bidc bidc bidc EXTY
inline $ZTYPE[*] $FNAMEEXTY($XTYPE x[+], $YTYPE y$SYSVARFGDECL)
{ /* AxS rank conjunction. Extend right argument */ 
 xframeshape = drop([-$XRANK], shape(x));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FN$XT$YT$ZT(x, y[iv]$SYSVARGKER);
	} : genarray(xframeshape, defcell);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, $XRANK$YRANK*, ., $CT

%Fragment nuax *** bidc bidc bidc EXTX
inline $ZTYPE[*] $FNAMEEXTX($XTYPE[+] x, $YTYPE[+] y$SYSVARFGDECL)
{ /* AxA rank conjunction. Extend left argument */ 
 yframeshape = drop([-$YRANK], shape(y));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FN$XT$YT$ZT(x, y[iv]$SYSVARGKER);
	} : genarray(yframeshape, defcell);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, $XRANK$YRANK*, ., $CT

%Fragment nuax *** bidc bidc bidc EXTY
inline $ZTYPE[*] $FNAMEEXTY($XTYPE[+] x, $YTYPE[+] y$SYSVARFGDECL)
{ /* AxA rank conjunction. Extend right argument */ 
 xframeshape = drop([-$YRANK], shape(x));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FN$XT$YT$ZT(x[iv], y$SYSVARGKER);
	} : genarray(xframeshape, defcell);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, $XRANK$YRANK*, ., $CT

%Fragment nuax *** bidc bidc bidc . 
inline $ZTYPE[*] $FNAME($XTYPE[+] x, $YTYPE[+] y$SYSVARFGDECL)
{ /* AxA rank conjunction. No extension */ 
/* requires checks for length error!! rbe 2005-09-05 */
 xframeshape = drop([-$XRANK], shape(x));
 yframeshape = drop([-$YRANK], shape(y));
 xcellshape =  take([-$XRANK], shape(x));
 ycellshape =  take([-$YRANK], shape(y));
 defcell = genarray($ZCELLSHAPE, $OTFILL);
 z = with {
	(. <= iv <= .)
  		: $FN$XT$YT$ZT(x[iv], y[iv]$SYSVARGKER);
	} : genarray(xframeshape, defcell);
  return(z);
} 
%Generate , $FN, $XT$YT$ZT, $XRANK$YRANK*, ., $CT

%
% Copyright (C) 2007 Robert Bernecky
%   This file is part of the APEX APL compiler run-time system.
%
%   The APEX APL compiler run-time system is free software; 
%   you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation; either
%   version 2.1 of the License, or (at your option) any later version.
%
%   The APEX APL compiler run-time system is distributed in the 
%   hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with the GNU C Library; if not, write to the Free
%   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
%   02111-1307 USA.  
%
