/*
 * Monadic miscfns
 * Will eventually handle:
 * 	shape, index generator, matrix inverse,
 * 	dex, nubsieve, thorn
 * Robert Bernecky 2007-05-13
 */

%Fragment iota x01 x bidc i .
inline int[.] $FNAME($YTYPE y, int QUADio)
{ /* Index generator on scalar */
/* HELP! Needs domain check for negative shp */
  z = QUADio+iota(toi(y));
  return( z);
}

%Fragment iota x01 x bidc i NonNeg
inline int[.] $FNAMENonNeg($YTYPE y, int QUADio)
{ /* Index generator on ScalarN when N is non-negative integer */
  z = QUADio+iota(toi(y));
  return( z);
}

%Fragment iota x11 x bidc i .
inline int[.] $FNAME($YTYPE[1] y, int QUADio)
{ /* Index generator on 1-element vector */
 /* HELP! Needs length error check */
/* HELP! Needs domain check for negative shp */
  z = QUADio+iota(toi(y[[0]]));
  return( z);
}

%Fragment iota x11 x bidc i NonNeg
inline int[.] $FNAMENonNeg($YTYPE[1] y, int QUADio)
{ /* Index generator on 1-element vector, known to be non-negative integer */
  z = QUADio+iota(toi(y[[0]]));
  return( z);
}

%Fragment ltak *** x bidc bidc .
inline $YTYPE[*] $FNAME($YTYPE[*] y) 
{ /* Dex on anything */
	return(y);
}

%Fragment rho x01 x bidc i . 
inline int[0] $FNAME($YTYPE y) 
{ /* Shape of scalar */
 return(shape(y));
}

%Fragment rho x11 x bidc i .
inline int[1]  $FNAME($YTYPE[.] y) 
{ /* Shape of vector */
 return(shape(y));
}

%Fragment rho x21 x bidc i .
inline int[2]  $FNAME($YTYPE[.,.] y) 
{ /* Shape of matrix (rank-2) */
 return(shape(y));
}

%Fragment rho x*1 x bidc i .
inline int[.]  $FNAME($YTYPE[+] y) 
{ /* Shape of rank-3 or higher */
 return(shape(y));
}

%Fragment quad x** x bidc bidc .
inline $ZTYPE[*] $FNAME($YTYPE[*] y, int QUADpp, int QUADpw)
{ /* {quad}{<-} anything */
	show(y);
	return(y);
}
%
% Copyright (C) 2007 Robert Bernecky
%   This file is part of the APEX APL compiler run-time system.
%
%   The APEX APL compiler run-time system is free software; 
%   you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation; either
%   version 2.1 of the License, or (at your option) any later version.
%
%   The APEX APL compiler run-time system is distributed in the 
%   hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with the GNU C Library; if not, write to the Free
%   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
%   02111-1307 USA.  
%
