% QUADfi and QUADvi code fragments
%
% Robert Bernecky 2006-03-05
%
% --------------- QUADfi fragments ----------------------------
%Fragment quadfi x01  x c d .
inline $ZTYPE[.] $FNAME($YTYPE y)
{ /* QUADfi on scalar */
if (
 z = toi(y)-toi('0');
 z = z *toi((z>=0) & (z<=9));
 return([z]);
}

%Fragment quadfi x11  x c d .
inline $ZTYPE[.] $FNAME($YTYPE[.] y)
{ /* BROKEN!!!  QUADfi on vector */
zshape = with {
	 ([0] <= iv < shape(y)-[1])
		: toi((' ' == y[iv]) && (' ' != y[iv+[1]]));
	} : fold(+, 0);
 zshape= zshape+1;
 z = genarray([zshape],-42.0);
 str = to_string(y);
 for(i=0; i<zshape; i++){
        v,str = strtod(str);
        z[i] = v;
        }
 return(z);
}

% --------------- QUADvi fragments ----------------------------
%Fragment quadvi x01  x c bid .
inline $ZTYPE[.] $FNAME($YTYPE y)
{ /* QUADvi on scalar */
 z = toi( (y>='0') & (y<='9'));
 return([z]);
}

%Fragment quadvi x11  x c bid .
inline $ZTYPE[.] $FNAME($YTYPE[.] y)
{ /* QUADvi on vector */
zshape = with {
	([0] <= iv < shape(y)-[1])
		: toi((' ' == y[iv]) && (' ' != y[iv+[1]]));
	} : fold(+, 0);
 zshape= zshape+1;
 z = genarray([zshape], false);
 str = to_string(y);
 for(i=0; i<zshape; i++){
        v,str = strtod(str);
        z[i] = 0.0 != v;
        }

 return(z);
}
%
% Copyright (C) 2007 Robert Bernecky
%   This file is part of the APEX APL compiler run-time system.
%
%   The APEX APL compiler run-time system is free software; 
%   you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation; either
%   version 2.1 of the License, or (at your option) any later version.
%
%   The APEX APL compiler run-time system is distributed in the 
%   hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with the GNU C Library; if not, write to the Free
%   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
%   02111-1307 USA.  
%
