% Code fragments for take and drop
%
% Robert Bernecky 2006-02-14
% These all just call sac take/drop now.

% %%%%%%%%%%%%%%%%%%% take %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Fragment take 001 bid bidc bidc .

inline $ZTYPE[.] $FNAME($XTYPE x, $YTYPE y)
{ /* Scalar take scalar */
  return(take([toi(x)],[y]));
}

%Fragment take 101 bid bidc bidc  .
inline $ZTYPE[*] $FNAME($XTYPE[.] x, $YTYPE y)
{ /* Vector take scalar */
  return(take(toi(x),[y]));
}

%Fragment take 011 bid bidc bidc .
%Fragment take 011 bid bidc bidc .
inline $ZTYPE[.] $FNAME($XTYPE x, $YTYPE[.] y)
{ /* Scalar take vector */ 
  return(take([toi(x)], y));
}

%
%Fragment take 11* bid bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE[1] x, $YTYPE[.] y)
{ /* Vector take Vector */ 
  return(take(toi(x),y));
}

%Fragment take 0** bid bidc bidc .
inline $ZTYPE[.,.] $FNAME($XTYPE x, $YTYPE[.,.] y)
{ /* scalar take matrix */
 return(take([toi(x)],y));
}

%Fragment take 1** bid bidc bidc .
inline $ZTYPE[.,.] $FNAME($XTYPE[.] x, $YTYPE[.,.] y)
{ /* vector take matrix */
  return(take(toi(x),y));
}

%% -------------------- drop code fragments ------------------------
%
%Fragment drop 001 bid bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE x, $YTYPE[*] y)
{ /* Scalar drop scalar */
  return(drop([toi(x)], [y]));
}

%Fragment drop 0** bid bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE x, $YTYPE[*] y)
{ /* Scalar drop non-scalar */
  return(drop([toi(x)], y));
}

%Fragment drop 111 bid bidc bidc .
%Fragment drop 1** bid bidc bidc .
inline $ZTYPE[*] $FNAME($XTYPE[.] x, $YTYPE[*] y)
{ /* Vector drop non-scalar */
  /* FIXME: Assert  dim(y)  == shape(x)[0]; */
  /* e.g, (,5)drop iota 5  */
  return(drop(toi(x), y));
}

%
% Copyright (C) 2007 Robert Bernecky
%   This file is part of the APEX APL compiler run-time system.
%
%   The APEX APL compiler run-time system is free software; 
%   you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation; either
%   version 2.1 of the License, or (at your option) any later version.
%
%   The APEX APL compiler run-time system is distributed in the 
%   hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with the GNU C Library; if not, write to the Free
%   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
%   02111-1307 USA.  
%
