

/*
 *  Global Switches
 */

#define SAC_DO_CHECK           0
#define SAC_DO_CHECK_TYPE      0
#define SAC_DO_CHECK_BOUNDARY  0
#define SAC_DO_CHECK_MALLOC    0
#define SAC_DO_CHECK_ERRNO     0
#define SAC_DO_CHECK_HEAP      0

#define SAC_DO_PHM             1
#define SAC_DO_APS             1
#define SAC_DO_DAO             1
#define SAC_DO_MSCA            1

#define SAC_DO_PROFILE         0
#define SAC_DO_PROFILE_WITH    0
#define SAC_DO_PROFILE_FUN     0
#define SAC_DO_PROFILE_INL     0
#define SAC_DO_PROFILE_LIB     0

#define SAC_DO_TRACE           0
#define SAC_DO_TRACE_REF       0
#define SAC_DO_TRACE_MEM       0
#define SAC_DO_TRACE_PRF       0
#define SAC_DO_TRACE_FUN       0
#define SAC_DO_TRACE_WL        0
#define SAC_DO_TRACE_AA        0
#define SAC_DO_TRACE_MT        0

#define SAC_DO_CACHESIM        0
#define SAC_DO_CACHESIM_ADV    0
#define SAC_DO_CACHESIM_GLOBAL 1
#define SAC_DO_CACHESIM_FILE   0
#define SAC_DO_CACHESIM_PIPE   0
#define SAC_DO_CACHESIM_IMDT   1

#define SAC_DO_MULTITHREAD     0
#define SAC_DO_THREADS_STATIC  1

#define SAC_DO_COMPILE_MODULE  0



/*
 *  Global Settings
 */

#ifndef NULL
#define NULL                      (void*) 0
#endif

#define SAC_SET_INITIAL_MASTER_HEAPSIZE      1048576
#define SAC_SET_INITIAL_WORKER_HEAPSIZE      65536
#define SAC_SET_INITIAL_UNIFIED_HEAPSIZE     0

#ifndef SAC_SET_MTMODE
#define SAC_SET_MTMODE               0
#endif

#ifndef SAC_SET_THREADS_MAX
#define SAC_SET_THREADS_MAX          32
#endif

#ifndef SAC_SET_THREADS
#define SAC_SET_THREADS              1
#endif

#ifndef SAC_SET_MASTERCLASS
#define SAC_SET_MASTERCLASS          0
#endif

#define SAC_SET_MAX_SYNC_FOLD        0
#define SAC_SET_NUM_SCHEDULERS       0

#define SAC_SET_CACHE_1_SIZE         -1
#define SAC_SET_CACHE_1_LINE         4
#define SAC_SET_CACHE_1_ASSOC        1
#define SAC_SET_CACHE_1_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_1_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_2_SIZE         -1
#define SAC_SET_CACHE_2_LINE         4
#define SAC_SET_CACHE_2_ASSOC        1
#define SAC_SET_CACHE_2_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_2_MSCA_FACTOR  0.00

#define SAC_SET_CACHE_3_SIZE         -1
#define SAC_SET_CACHE_3_LINE         4
#define SAC_SET_CACHE_3_ASSOC        1
#define SAC_SET_CACHE_3_WRITEPOL     SAC_CS_default
#define SAC_SET_CACHE_3_MSCA_FACTOR  0.00

#define SAC_SET_CACHESIM_HOST        ""
#define SAC_SET_CACHESIM_FILE        "ipdd.cs"
#define SAC_SET_CACHESIM_DIR         "/tmp"
#define SAC_SET_MAXFUN               0
#define SAC_SET_MAXFUNAP             1



/*
 *  Includes
 */


#include "sac.h"


/*
 *  SAC-Program ipdd.sac :
 */


/*
 *  Global Definitions
 */

SAC_MT_DEFINE()
SAC_PF_DEFINE()
SAC_HM_DEFINE()


/*
 *  prototypes for externals (FUNDECS)
 */

extern 
/*
 * ND_FUN_DEC( fmod, (double, (SCL, (NHD, (NUQ,)))), 2, in_nodesc, double, (SACl_X, (SCL, (NHD, (NUQ,)))), in_nodesc, double, (SACl_Y, (SCL, (NHD, (NUQ,)))))
 */
SAC_ND_TYPE_NT( (double, (SCL, (NHD, (NUQ,))))) fmod( SAC_ND_PARAM_in_nodesc( (SACl_X, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in_nodesc( (SACl_Y, (SCL, (NHD, (NUQ,)))), double));

extern 
/*
 * ND_FUN_DEC( PrintDoubleArray, , 4, in_nodesc, int, (SACl_d, (SCL, (NHD, (NUQ,)))), in_nodesc, int, (SACl_s, (AKD, (NHD, (NUQ,)))), in_nodesc, double, (SACl_a, (AUD, (NHD, (NUQ,)))), out_nodesc, int, (SAC_arg_4, (SCL, (NHD, (NUQ,)))))
 */
void PrintDoubleArray( SAC_ND_PARAM_in_nodesc( (SACl_d, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_s, (AKD, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in_nodesc( (SACl_a, (AUD, (NHD, (NUQ,)))), double), SAC_ND_PARAM_out_nodesc( (SAC_arg_4, (SCL, (NHD, (NUQ,)))), int));



/*
 *  prototypes for locals (FUNDEFS)
 */

extern 
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACwf__MAIN__plusDDD__d_S__d_S, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (AUD, (NHD, (NUQ,)))), in, double, (SACl_y, (AUD, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__plusDDD__d_S__d_S( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (AUD, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (AUD, (NHD, (NUQ,)))), double));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__ipddXID__i__i, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, int, (SACl_siz, (SCL, (NHD, (NUQ,)))), in, int, (SACl_QUADio, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__ipddXID__i__i( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_siz, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in( (SACl_QUADio, (SCL, (NHD, (NUQ,)))), int));

extern 
/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double));



/*
 *  function definitions (FUNDEFS)
 */

/* wrapper function */
/*
 * ND_FUN_DEC( SACwf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_FUN_AP( SACf__MAIN__main, , 1, out, (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))))
   */
  SACf__MAIN__main( SAC_ND_ARG_out( (SACp_cwc_2183, (SCL, (NHD, (NUQ,))))));

  /*
   * ND_REFRESH__MIRROR( (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOOP()

  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_2183, (SCL, (NHD, (NUQ,)))))
  return;
}

/* wrapper function */
/*
 * ND_FUN_DEC( SACwf__MAIN__plusDDD__d_S__d_S, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (AUD, (NHD, (NUQ,)))), in, double, (SACl_y, (AUD, (NHD, (NUQ,)))))
 */
void SACwf__MAIN__plusDDD__d_S__d_S( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (AUD, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (AUD, (NHD, (NUQ,)))), double))
{ 
  /*
   * ND_DECL( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), double, -2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))));

  /*
   * ND_DECL( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), double, -2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))));

  /*
   * ND_DECL( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), double, -2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))));

  /*
   * ND_DECL( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), double, -2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))));

  /*
   * ND_DECL( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_DECL__MIRROR_PARAM( (SACl_y, (AUD, (NHD, (NUQ,)))), -2)
   */
  int SAC_ND_A_MIRROR_SIZE( (SACl_y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC_SIZE( (SACl_y, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACl_y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC_DIM( (SACl_y, (AUD, (NHD, (NUQ,)))));

  /*
   * ND_DECL__MIRROR_PARAM( (SACl_x, (AUD, (NHD, (NUQ,)))), -2)
   */
  int SAC_ND_A_MIRROR_SIZE( (SACl_x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC_SIZE( (SACl_x, (AUD, (NHD, (NUQ,)))));
  int SAC_ND_A_MIRROR_DIM( (SACl_x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC_DIM( (SACl_x, (AUD, (NHD, (NUQ,)))));

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_DIM__DATA( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), 0, (SACl_x, (AUD, (NHD, (NUQ,)))), -2)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), 0), 0)
  SAC_ND_FREE( (SACp_emal_6750__cwc_2283, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_ASSIGN( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), -2, (SACl_x, (AUD, (NHD, (NUQ,)))), -2, )
   */
  SAC_ND_A_DESC( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACl_x, (AUD, (NHD, (NUQ,)))));
  SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACl_x, (AUD, (NHD, (NUQ,)))));
  SAC_ND_A_MIRROR_DIM( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DIM( (SACl_x, (AUD, (NHD, (NUQ,)))));
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), (SACl_x, (AUD, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), -2, (SACl_y, (AUD, (NHD, (NUQ,)))), -2, )
   */
  SAC_ND_A_DESC( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACl_y, (AUD, (NHD, (NUQ,)))));
  SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACl_y, (AUD, (NHD, (NUQ,)))));
  SAC_ND_A_MIRROR_DIM( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DIM( (SACl_y, (AUD, (NHD, (NUQ,)))));
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), (SACl_y, (AUD, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), (SACp_emal_6749__cwc_2287, (SCL, (NHD, (NUQ,)))), )

  if (SACp_pinl_6892_____cwc_2287) 
  { 
    SAC_ND_FREE( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_DIM__DATA( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), -2)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), 0), 0)
    SAC_ND_FREE( (SACp_pinl_6900__emal_6748__pinl_6722__cwc_2284, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), -2, (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), -2, )
     */
    SAC_ND_A_DESC( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_DIM( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DIM( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))));
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), -2, (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), -2, )
     */
    SAC_ND_A_DESC( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_DIM( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,))))) = SAC_ND_A_DIM( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))));
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), )

    /*
     * ND_ASSIGN( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6901__emal_6747__pinl_6723__cwc_2286, (SCL, (NHD, (NUQ,)))), )

    if (SACp_pinl_6895_______cwc_2286) 
    { 
      SAC_ND_FREE( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), 1, 0)
      SAC_ND_COPY__DATA( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), )
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), 1, )
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,))))) == 0), 818, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), 1, 0)
      SAC_ND_COPY__DATA( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), )
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), 1, )
      /*
       * ND_FUN_AP( SACf__MAIN__plusDDD__d__d, , 3, out, (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), in, (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,)))), in, (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,)))))
       */
      SACf__MAIN__plusDDD__d__d( SAC_ND_ARG_out( (SACp_cwc_2282, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in( (SACp_pinl_6897___emal_6745__asd_6743__pinl_6719___x, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in( (SACp_pinl_6896___emal_6746__asd_6744__pinl_6720___y, (SCL, (NHD, (NUQ,))))));

      /*
       * ND_REFRESH__MIRROR( (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_NOOP()

    }
    else
    { 
      SAC_ND_FREE( (SACp_pinl_6895_______cwc_2286, (SCL, (NHD, (NUQ,)))), )
      /*
       * DISPATCH_ERROR( 1, (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), "_MAIN::plusDDD :: double[*] double[*] -> double ", 2, (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))))
       */
      SAC_RuntimeError_Mult( 4, "No appropriate instance of function \"" "_MAIN::plusDDD :: double[*] double[*] -> double " "\" found!", "Shape of arguments:", "  %s", SAC_PrintShape( SAC_ND_A_DESC( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))))), "  %s", SAC_PrintShape( SAC_ND_A_DESC( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))))));
      return; /* dummy; is this really a good idea??? */

      SAC_ND_DEC_RC_FREE( (SACp_pinl_6894______y, (AUD, (NHD, (NUQ,)))), 1, )
      SAC_ND_DEC_RC_FREE( (SACp_pinl_6893______x, (AUD, (NHD, (NUQ,)))), 1, )
    }
  }
  else
  { 
    SAC_ND_FREE( (SACp_pinl_6892_____cwc_2287, (SCL, (NHD, (NUQ,)))), )
    /*
     * DISPATCH_ERROR( 1, (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))), "_MAIN::plusDDD :: double[*] double[*] -> double ", 2, (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))))
     */
    SAC_RuntimeError_Mult( 4, "No appropriate instance of function \"" "_MAIN::plusDDD :: double[*] double[*] -> double " "\" found!", "Shape of arguments:", "  %s", SAC_PrintShape( SAC_ND_A_DESC( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))))), "  %s", SAC_PrintShape( SAC_ND_A_DESC( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))))));
    return; /* dummy; is this really a good idea??? */

    SAC_ND_DEC_RC_FREE( (SACp_pinl_6891____y, (AUD, (NHD, (NUQ,)))), 1, )
    SAC_ND_DEC_RC_FREE( (SACp_pinl_6890____x, (AUD, (NHD, (NUQ,)))), 1, )
  }
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_cwc_2282, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__main, , 1, out, int, (SAC_arg_1, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__main( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACl_r_0, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACl_r_0, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACl_r_0, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  SAC_ND_ALLOC_BEGIN( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))), 0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,))))) == 0), 857, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), 400)
  /*
   * ND_FUN_AP( SACf__MAIN__ipddXID__i__i, , 3, out, (SACl_r_0, (SCL, (NHD, (NUQ,)))), in, (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,)))), in, (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,)))))
   */
  SACf__MAIN__ipddXID__i__i( SAC_ND_ARG_out( (SACl_r_0, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in( (SACp_emal_6755_n_0, (SCL, (NHD, (NUQ,))))), SAC_ND_ARG_in( (SACp_emal_6756_QUADio_1, (SCL, (NHD, (NUQ,))))));

  /*
   * ND_REFRESH__MIRROR( (SACl_r_0, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOOP()

  SAC_ND_COPY__DATA( (SACl_r_0, (SCL, (NHD, (NUQ,)))), (SACl_r_0, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, ==, SAC_ND_READ( (SACl_r_0, (SCL, (NHD, (NUQ,)))), 0), 25000833250000.0)
  SAC_ND_FREE( (SACl_r_0, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_COPY__DATA( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6753__pinl_4973___flat_35, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 1, SAC_ND_READ( (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))), 0))
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6752__pinl_4980___flat_3, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__ipddXID__i__i, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, int, (SACl_siz, (SCL, (NHD, (NUQ,)))), in, int, (SACl_QUADio, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__ipddXID__i__i( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_siz, (SCL, (NHD, (NUQ,)))), int), SAC_ND_PARAM_in( (SACl_QUADio, (SCL, (NHD, (NUQ,)))), int))
{ 
  /*
   * ND_DECL( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), int, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), bool, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), bool, )
  SAC_ND_DECL__DESC( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), double, -4)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), double, -4)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), double, -4)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), double, -4)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) = 2;

  /*
   * ND_DECL( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), double, -3)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), )
  int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0);
  int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))));
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), int, 1, 2)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 0) = 2;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,))))) = 2;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,))))) = 1;

  /*
   * ND_DECL( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), int, 1, 1)
   */
  SAC_ND_DECL__DATA( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), )
  const int SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) = 1;
  const int SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;
  const int SAC_ND_A_MIRROR_DIM( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,))))) = 1;


  /*
   * ND_DECL__MIRROR_PARAM( (SACl_QUADio, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_DECL__MIRROR_PARAM( (SACl_siz, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_COPY__DATA( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), (SACl_siz, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, SAC_ND_READ( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_COPY__DATA( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6872__pinl_4991___flat_86)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) == 1), 781, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6872__pinl_4991___flat_86;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) >= 0), 781, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,))))) == 0), 781, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,))))) == 0), 781, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), 1)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), 1)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), 1)
     */
    SAC_ND_WRITE( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACl_QUADio, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * WL_ASSIGN( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,))))))), 781, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0)), 781, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), (SACp_emal_6869__pinl_5002___flat_88, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5009__flat_119, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6872__pinl_4991___flat_86, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6694__pinl_5006_res, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5008__flat_118_i, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_DEC_RC_FREE( (SACl_QUADio, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,))))) == 1), 727, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 0) == 1), 727, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), 0), );

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,))))) == 0), 731, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 0.0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,))))) == 0), 727, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6867__pinl_5039__flat_207, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6865__pinl_5025__wla_4962__flat_207)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) == 1), 731, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6865__pinl_5025__wla_4962__flat_207;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) >= 0), 731, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,))))) == 1), 731, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 731, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,))))) == 0), 731, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,))))) == 0), 731, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    SAC_ND_WRITE( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_SET_IDXVEC( 0, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,))))) == 0), 728, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_SEL__DATA_id( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), -3, ...)"))
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,))))) == 1), 728, "1st argument of _sel_ is not a vector!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))))), 728, "Length of index vector used for _sel_ does not match rank of argument array!");
    { int SAC_idx;
      SAC_idx = SAC_ND_READ( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 0);
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), SAC_idx, )
    }

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_COPY__DATA( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6863__pinl_5033__flat_209, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, 0.5, SAC_ND_READ( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 0))
    /*
     * WL_ASSIGN( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,))))))), 731, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0)), 731, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6862__pinl_5022___flat_14, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6865__pinl_5025__wla_4962__flat_207, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6695__pinl_5030_z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5029__nt2ot_2132, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5034__flat_208_iv, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6868__pinl_5006_res, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,))))) == 0), 297, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, 0)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), -3, 0)"))
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), SAC_ND_A_SHAPE( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), 0))

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,))))) == 1), 762, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 0) == 1), 762, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), 0), )

  SAC_ND_FREE( (SACp_emal_6859__pinl_5157___flat_69, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_ASSIGN__DESC( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))))
   */
  SAC_ND_A_DESC( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))));

  SAC_ND_SET__RC( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), 1)
  /*
   * ND_PRF_RESHAPE__SHAPE_id( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))))
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_RESHAPE__SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), -3, ...)"))
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,))))) == 1), 762, "1st argument of _reshape_ is not a vector!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) == 1), 762, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), 0) = SAC_ND_READ( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), 0);
    SAC_ND_A_DESC_SIZE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,))))) >= 0), 762, "Array with size <0 found!");
  }

  SAC_ND_ASSIGN__DATA( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), (SACp_emal_6860__pinl_5030_z, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6858__pinl_5205__flat_121, (AKS, (NHD, (NUQ,)))), )
  SAC_NOOP( )
  /*
   * ND_CHECK_REUSE( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0, (SACl_siz, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,))))) == 0), 87, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0, 0)
  SAC_ND_INC_RC( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, SAC_ND_READ( (SACl_siz, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACl_siz, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_DEC_RC_FREE( (SACl_siz, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 0) == 1), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 1, 1, 0, )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), 0, 0, )

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_IDXS2OFFSET( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 1, 0, 1, 1)
   */
  SAC_ND_WRITE( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0) = 0;

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_SHAPE_SEL__DATA_id( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))))
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE_SEL__DATA( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))))"))
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "1st argument of _shape_sel_ is not a vector!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "Length of index vector used for _shape_sel_ is not one!");
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))),SAC_ND_A_DESC_SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))) ,0)))

  SAC_ND_FREE( (SACp_emal_6855__pinl_5167___new_idx, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,))))) == 0), 101, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, <=, SAC_ND_READ( (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 0))
  /*
   * ND_ASSIGN( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,))))) == 0), 765, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), (SACp_emal_6852__pinl_5180___flat_44, (SCL, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,))))) == 0), 765, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), (SACp_emal_6853__pinl_5166____flat_139, (SCL, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,))))) == 0), 765, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), (SACp_emal_6856__assoc_6632, (SCL, (NHD, (NUQ,)))), )

  /*
   * ND_ASSIGN( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), -3, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) == 1), 765, "Assignment with incompatible types found!");
  SAC_ND_A_DESC( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))));
  SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), 0) = SAC_ND_A_SHAPE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), 0);
  SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))));
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), (SACp_emal_6857__pinl_5204_ry, (AKD, (NHD, (NUQ,)))), )

  if (SACp_pinl_6908_____flat_126) 
  { 
    SAC_ND_FREE( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 1, SACp_pinl_6909____yxrho)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) == 1), 767, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0) = SACp_pinl_6909____yxrho;
      SAC_ND_A_DESC_SIZE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) >= 0), 767, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,))))) == 1), 767, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 0) == 1), 767, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,))))) == 0), 767, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,))))) == 0), 767, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,))))) == 0), 767, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,))))) == 1), 767, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))))), 767, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      /*
       * WL_ASSIGN( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,))))))), 767, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0)), 767, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6918__emal_6758__pinl_6737__flat_134, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6928___wlidx_6692_z, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6925___flat_132_iv, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6926___flat_133, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) == 1), 765, "Assignment with incompatible types found!");
    SAC_ND_A_DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0) = SAC_ND_A_SHAPE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0);
    SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))));
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), (SACp_pinl_6919__emal_6757__pinl_5198_z, (AKD, (NHD, (NUQ,)))), )

  }
  else
  { 
    SAC_ND_FREE( (SACp_pinl_6908_____flat_126, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 1, SACp_pinl_6910____zxrho)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) == 1), 770, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0) = SACp_pinl_6910____zxrho;
      SAC_ND_A_DESC_SIZE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) >= 0), 770, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,))))) == 0), 770, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,))))) == 0), 770, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,))))) == 0), 89, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), 1, 0)
      SAC_ND_PRF_SxS__DATA( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, %, SAC_ND_READ( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 1, 1)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,))))) == 1), 770, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 0) == 1), 770, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_CREATE__ARRAY__DATA( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 1, 1, (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ND_WRITE_COPY( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_FREE( (SACp_pinl_6913__emal_6763__pinl_6734___flat_48, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_ALLOC_BEGIN( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,))))) == 0), 770, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,))))) == 1), 770, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))))), 770, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_FREE( (SACp_pinl_6914__emal_6762__pinl_6740__flat_144, (AKS, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,))))))), 770, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0)), 770, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), 0), (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6915__emal_6761__pinl_6741__flat_143, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6923___flat_142, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_pinl_6910____zxrho, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6929___wlidx_6693_z__SSA0_1, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6922___flat_141_i, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6909____yxrho, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6911____ry, (AKD, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), -3, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) == 1), 765, "Assignment with incompatible types found!");
    SAC_ND_A_DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))));
    SAC_ND_A_MIRROR_SHAPE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), 0) = SAC_ND_A_SHAPE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), 0);
    SAC_ND_A_MIRROR_SIZE( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_SIZE( (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))));
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), (SACp_pinl_6916__emal_6760__pinl_5198_z__SSA20_1, (AKD, (NHD, (NUQ,)))), )

  }
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1, 2)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 0) == 2), 165, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_CREATE__ARRAY__DATA( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_ND_WRITE_COPY( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 0), )
  SAC_ND_WRITE_COPY( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), 0), )

  SAC_ND_FREE( (SACp_emal_6873__pinl_4989___flat_12, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC__DESC( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 2)
  SAC_ND_FREE__DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))))
  /*
   * ND_ASSIGN__DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))))
   */
  SAC_ND_A_DESC( (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_DESC( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))));

  SAC_ND_SET__RC( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1)
  /*
   * ND_PRF_RESHAPE__SHAPE_id( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))))
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_RESHAPE__SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, ...)"))
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,))))) == 1), 773, "1st argument of _reshape_ is not a vector!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) == 2), 773, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 0) = SAC_ND_READ( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 0);
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1) = SAC_ND_READ( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), 1);
    SAC_ND_A_DESC_SIZE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) >= 0), 773, "Array with size <0 found!");
  }

  SAC_ND_ASSIGN__DATA( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), (SACp_pinl_5198_z, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6851__pinl_5197__flat_147__SSA17_2, (AKS, (NHD, (NUQ,)))), )
  SAC_NOOP( )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, 2)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) == 1), 749, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 0) == 2), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 0), );
  SAC_ND_WRITE_COPY( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1), );

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,))))) == 0), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, 0)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, 0)"))
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 0))

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,))))) == 0), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, 1)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, 1)"))
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1))

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1, 2)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 2, SACp_emal_6847__pinl_6615__flat_188, SACp_emal_6848__pinl_6616__flat_191)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) == 2), 749, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6847__pinl_6615__flat_188;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1) = SACp_emal_6848__pinl_6616__flat_191;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) >= 0), 749, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1, 2)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,))))) == 0), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,))))) == 0), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,))))) == 0), 749, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 2)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);
    int SAC_WL_MT_SCHEDULE_START( 1);
    int SAC_WL_MT_SCHEDULE_STOP( 1);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 2)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0);
    int SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 2)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0) = 1 * SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1);
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0);
    SAC_WL_MT_SCHEDULE_START( 1) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 1) = SAC_ND_READ( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 2)
     */
    SAC_ND_WRITE( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0)
      + SAC_WL_MT_SCHEDULE_START( 1) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    /*
     * WL_SET_OFFSET( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 0, 2, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))))
     */
    SAC_ND_WRITE( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 0) 
      = ( SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0)
       + SAC_WL_MT_SCHEDULE_START( 1) ) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 1, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 1, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1, 2)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,))))) == 1), 749, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 0) == 2), 749, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0), )
    SAC_ND_WRITE_COPY( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0), )

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_SEL__DATA_id( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 2, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, ...)"))
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,))))) == 1), 126, "1st argument of _sel_ is not a vector!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))))), 126, "Length of index vector used for _sel_ does not match rank of argument array!");
    { int SAC_idx;
      SAC_idx = ( SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), 1) );
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), SAC_idx, )
    }

    SAC_ND_FREE( (SACp_emal_6845__pinl_6606__flat_198, (AKS, (NHD, (NUQ,)))), )
    /*
     * WL_ASSIGN( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), 2, (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,))))))), 749, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1)), 749, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6844__pinl_6605__flat_197, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 1, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 1, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6609__flat_196, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 2)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6848__pinl_6616__flat_191, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6847__pinl_6615__flat_188, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6696__pinl_6604_z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_6608__flat_194_i, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_6607__flat_195_j, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,))))) == 0), 376, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, 0)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, 0)"))
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0))

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,))))) == 0), 376, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, 1)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SHAPE_SEL__DATA( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, 1)"))
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1))

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1, 2)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 2, SACp_emal_6841__pinl_6641__flat_1115, SACp_emal_6842__pinl_6642__flat_1118)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) == 2), 376, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6841__pinl_6641__flat_1115;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1) = SACp_emal_6842__pinl_6642__flat_1118;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) >= 0), 376, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1, 2)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,))))) == 0), 376, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,))))) == 0), 376, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,))))) == 0), 376, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 2)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);
    int SAC_WL_MT_SCHEDULE_START( 1);
    int SAC_WL_MT_SCHEDULE_STOP( 1);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 2)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0);
    int SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 2)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0) = 1 * SAC_ND_A_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1);
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0);
    SAC_WL_MT_SCHEDULE_START( 1) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 1) = SAC_ND_READ( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 2)
     */
    SAC_ND_WRITE( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0)
      + SAC_WL_MT_SCHEDULE_START( 1) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    /*
     * WL_SET_OFFSET( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 0, 2, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))))
     */
    SAC_ND_WRITE( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 0) 
      = ( SAC_ND_A_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0)
       + SAC_WL_MT_SCHEDULE_START( 1) ) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 1, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 1, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1, 2)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,))))) == 1), 376, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 0) == 2), 376, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_CREATE__ARRAY__DATA( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ND_WRITE_COPY( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0), )
    SAC_ND_WRITE_COPY( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0), )

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_SEL__DATA_id( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 2, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4, ...)"))
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,))))) == 1), 126, "1st argument of _sel_ is not a vector!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))))), 126, "Length of index vector used for _sel_ does not match rank of argument array!");
    { int SAC_idx;
      SAC_idx = ( SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), 1) );
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), SAC_idx, )
    }

    SAC_ND_FREE( (SACp_emal_6839__pinl_6637__flat_1125, (AKS, (NHD, (NUQ,)))), )
    /*
     * WL_ASSIGN( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), 2, (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,))))))), 376, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1)), 376, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_FREE( (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))), )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), (SACp_emal_6838__pinl_6636___flat_117, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 1, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 1, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6640__flat_1123, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 2)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6842__pinl_6642__flat_1118, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6841__pinl_6641__flat_1115, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6697__pinl_5521_yt, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_6639__flat_1121_i, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_6638__flat_1122_j, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,))))) == 1), 802, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 0) == 1), 802, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, -1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, -1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = -1;
    if ((-1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))))), 802, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, 2)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,))))) == 1), 803, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 0) == 2), 803, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), -4)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 0), );
  SAC_ND_WRITE_COPY( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_A_SHAPE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), 1), );

  SAC_ND_FREE( (SACp_emal_6843__pinl_6604_z, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,))))) == 1), 803, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 0) == 1), 803, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, 1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), 1, 1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = 1;
    if ((1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))))), 803, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_FREE( (SACp_emal_6835__pinl_5516__flat_81, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,))))) == 0), 82, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))))"))
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,))))) == 0), 82, "1st argument of _idx_sel_ is not a scalar!");
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), )

  SAC_ND_FREE( (SACp_emal_6834__pinl_5514_rs, (AKS, (NHD, (NUQ,)))), )
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))))"))
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,))))) == 0), 82, "1st argument of _idx_sel_ is not a scalar!");
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), )

  SAC_ND_FREE( (SACp_emal_6836__pinl_5517_ls, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, 2)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 0) == 2), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 0), );
  SAC_ND_WRITE_COPY( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_A_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1), );

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 0) == 1), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, 1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), 1, 1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = 1;
    if ((1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))))), 126, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_FREE( (SACp_emal_6831__pinl_5489___flat_110, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 0) == 1), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, 1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), 1, 1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = 1;
    if ((1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))))), 126, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_FREE( (SACp_emal_6849__pinl_6617__flat_193, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6830__pinl_5485__new_shape, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6829__pinl_6624_new_shape, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_CREATE__SCALAR__DATA( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), 1.0)
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1, 2)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 2, SACp_emal_6854__ive_6706__pinl_5167___new_idx, SACp_emal_6833__pinl_5362___flat_826)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) == 2), 808, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6854__ive_6706__pinl_5167___new_idx;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1) = SACp_emal_6833__pinl_5362___flat_826;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) >= 0), 808, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1, 2)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,))))) == 0), 808, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,))))) == 0), 808, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,))))) == 0), 808, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 2)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);
    int SAC_WL_MT_SCHEDULE_START( 1);
    int SAC_WL_MT_SCHEDULE_STOP( 1);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 2)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0);
    int SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 2)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0) = 1 * SAC_ND_A_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1);
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0);
    SAC_WL_MT_SCHEDULE_START( 1) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 1) = SAC_ND_READ( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 2)
     */
    SAC_ND_WRITE( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0)
      + SAC_WL_MT_SCHEDULE_START( 1) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    /*
     * WL_SET_OFFSET( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 0, 2, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 2, (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))))
     */
    SAC_ND_WRITE( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 0) 
      = ( SAC_ND_A_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0)
       + SAC_WL_MT_SCHEDULE_START( 1) ) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1);

    SAC_WL_STRIDE_LOOP0_BEGIN( 1, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 1, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_INC_RC( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6828__wla_6656__pinl_5485__new_shape)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6828__wla_6656__pinl_5485__new_shape;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) >= 0), 126, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1, 2)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 0) == 2), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_CREATE__ARRAY__DATA( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ND_WRITE_COPY( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0), )
      SAC_ND_WRITE_COPY( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 2, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), -4, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))))), 126, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = ( SAC_ND_A_SHAPE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), 1) );
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_FREE( (SACp_emal_6823__pinl_5478__new_idx, (AKS, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,))))))), 126, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0)), 126, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), (SACp_emal_6822__pinl_5477___flat_117, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5479___flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_wlidx_6699__pinl_5503__flat_97, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_nt2ot_6635, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 0) == 1), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_PRF_SHAPE__DATA( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3)
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3)"))
    SAC_ND_WRITE_COPY( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), 0), );

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, 0, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 1, 0)"))
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), 0, )

    SAC_ND_FREE( (SACp_emal_6820__pinl_6649_shp, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6819__wla_6674__pinl_6649_shp)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6819__wla_6674__pinl_6649_shp;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) >= 0), 165, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,))))) == 1), 165, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))))), 165, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_COPY__DATA( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,))))))), 165, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), 0)), 165, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), (SACp_emal_6817__pinl_6645__flat_80, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_emal_6819__wla_6674__pinl_6649_shp, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_wlidx_6700__pinl_5502__flat_96, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_nt2ot_6666, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6821__pinl_5503__flat_97, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6646__flat_78_iv, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6827__wla_6658__pinl_6624_new_shape)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6827__wla_6658__pinl_6624_new_shape;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) >= 0), 126, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1, 2)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 0) == 2), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_CREATE__ARRAY__DATA( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ND_WRITE_COPY( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0), )
      SAC_ND_WRITE_COPY( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,))))) == 0), 126, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 2, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), -4, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,))))) == 1), 126, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))))), 126, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = ( SAC_ND_A_SHAPE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), 1) );
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_FREE( (SACp_emal_6813__pinl_6620_new_idx, (AKS, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,))))))), 126, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0)), 126, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), (SACp_emal_6812__pinl_6619__flat_117, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6621__flat_116_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_wlidx_6701__pinl_5500__flat_94, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_nt2ot_6634, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 0) == 1), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_PRF_SHAPE__DATA( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3)
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3)"))
    SAC_ND_WRITE_COPY( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), 0), );

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, 0, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 1, 0)"))
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), 0, )

    SAC_ND_FREE( (SACp_emal_6810__pinl_6655_shp, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6809__wla_6676__pinl_6655_shp)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6809__wla_6676__pinl_6655_shp;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) >= 0), 165, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,))))) == 1), 165, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,))))) == 0), 165, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,))))) == 1), 165, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))))), 165, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_COPY__DATA( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,))))))), 165, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0)), 165, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), (SACp_emal_6807__pinl_6651__flat_80, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_emal_6809__wla_6676__pinl_6655_shp, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_wlidx_6702__pinl_5499__flat_93, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_nt2ot_6665, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6811__pinl_5500__flat_94, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6652__flat_78_iv, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,))))) == 1), 112, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 0) == 1), 112, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_PRF_SHAPE__DATA( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3)
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3)"))
    SAC_ND_WRITE_COPY( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), 0), );

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, 0, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 1, 0)"))
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), 0, )

    SAC_ND_FREE( (SACp_emal_6804__pinl_6673_shp, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6803__wla_6690__pinl_6673_shp)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) == 1), 112, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6803__wla_6690__pinl_6673_shp;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) >= 0), 112, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))) == 1), 112, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 112, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))) == 1), 112, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))))), 112, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,))))) == 0), 112, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))) == 1), 112, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))))), 112, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_PRF_SxS__DATA( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, *, SAC_ND_READ( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_emal_6801__pinl_6669__flat_976, (SCL, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,))))))), 112, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0)), 112, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), (SACp_emal_6800__pinl_6668__flat_975, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_emal_6803__wla_6690__pinl_6673_shp, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_wlidx_6703__pinl_5498__flat_92, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_nt2ot_6678, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6815__pinl_5502__flat_96, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6805__pinl_5499__flat_93, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6670__flat_973_iv, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,))))) == 1), 813, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 0) == 1), 813, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_PRF_SHAPE__DATA( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3)
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3)"))
    SAC_ND_WRITE_COPY( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), 0), );

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, 0, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 1, 0)"))
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), 0, )

    SAC_ND_FREE( (SACp_emal_6797__pinl_6689__flat_73, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 814, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_ASSIGN( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), )

    SAC_PF_BEGIN_WITH( fold)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_NOOP( )
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))))), 814, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_COPY__DATA( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_COPY__DATA( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_CHECK_REUSE( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_NOOP()

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
      SAC_ND_INC_RC( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_COPY__DATA( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_DEC_RC_FREE( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 1, )
      SAC_ND_PRF_SxS__DATA( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_emal_6795__pinl_6686__flat_76, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), (SACp_emal_6792__pinl_6680____flat_8, (SCL, (NHD, (NUQ,)))), )

      /*
       * WL_FOLD( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))))
       */
      SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)));
      /* fold operation */

      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( fold)
    SAC_ND_FREE( (SACp_emal_6796__pinl_6683__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6685__nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6798__pinl_5498__flat_92, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_6687__flat_74_iv, (AKS, (NHD, (NUQ,)))), )
    /*
     * WL_ASSIGN( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), 2, (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,))))))), 808, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1)), 808, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), 0), (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_DEC_RC_FREE( (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5497__flat_91, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 1, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 1, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5507__flat_90, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 2, 0, 0, SAC_ND_READ( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 2)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6833__pinl_5362___flat_826, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6854__ive_6706__pinl_5167___new_idx, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6698_TMP_32, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6850_m_0, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6837__pinl_5521_yt, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5506__flat_88_i, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5505__flat_89_j, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6828__wla_6656__pinl_5485__new_shape, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6827__wla_6658__pinl_6624_new_shape, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6826__pinl_6671__flat_967, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, 2)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) == 1), 826, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 0) == 2), 826, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 0), );
  SAC_ND_WRITE_COPY( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_A_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1), );

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,))))) == 1), 827, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 0) == 1), 827, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, -1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, -1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = -1;
    if ((-1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))))), 827, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,))))) == 0), 828, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6788__pinl_5611_zrho, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,))))) == 1), 81, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 0) == 1), 81, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_DROP__DATA( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, 1, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_DROP__DATA( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), 1, 1)"))
  { int SAC_cnt, SAC_off;
    SAC_off = 1;
    if ((1 < 0)) { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) + SAC_off;
      SAC_off = 0;
    }
    else { 
      SAC_cnt = SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,))))) - SAC_off;
    }
    SAC_ASSURE_TYPE_LINE( (SAC_cnt <= SAC_ND_A_SIZE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))))), 81, "1st argument of _drop_SxV_ is out of range!");
    { int SAC_i;
      for (SAC_i = 0; SAC_i < SAC_cnt; SAC_i++) { 
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), SAC_i, (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), SAC_off + SAC_i, );
      }
    }
  }

  SAC_ND_FREE( (SACp_emal_6789__pinl_5614_sy, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,))))) == 0), 81, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6786__pinl_5575__new_shape, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6787__pinl_5598__wla_4939__flat_62)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) == 1), 830, "Assignment with incompatible types found!");
  { int SAC_size = 1;
    SAC_size *= 
    SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0) = 
    SAC_ND_A_DESC_SHAPE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6787__pinl_5598__wla_4939__flat_62;
    SAC_ND_A_DESC_SIZE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) = SAC_size;
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) >= 0), 830, "Array with size <0 found!");
  }

  SAC_ND_ALLOC_END( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,))))) == 0), 830, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,))))) == 0), 830, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), 1, 0)
  SAC_PF_BEGIN_WITH( genarray)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
        int SAC_WL_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0);

    /*
     * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    {
      int SAC_i;
      SAC_WL_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0) = 1;
    }

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0);

    /*
     * WL_INIT_OFFSET( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), 1)
     */
    SAC_ND_WRITE( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), 0)
      = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_ND_INC_RC( (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 1, SACp_emal_6785__pinl_5563___wla_4936__flat_2092)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) == 1), 81, "Assignment with incompatible types found!");
    { int SAC_size = 1;
      SAC_size *= 
      SAC_ND_A_MIRROR_SHAPE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0) = 
      SAC_ND_A_DESC_SHAPE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0) = SACp_emal_6785__pinl_5563___wla_4936__flat_2092;
      SAC_ND_A_DESC_SIZE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) = SAC_ND_A_MIRROR_SIZE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) = SAC_size;
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_MIRROR_SIZE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) >= 0), 81, "Array with size <0 found!");
    }

    SAC_ND_ALLOC_END( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,))))) == 0), 81, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_ND_ALLOC_BEGIN( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,))))) == 0), 81, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), 1, 0)
    SAC_PF_BEGIN_WITH( genarray)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * WL_DECLARE_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
            int SAC_WL_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0);

      /*
       * WL_DEFINE_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      {
        int SAC_i;
        SAC_WL_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0) = 1;
      }

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0);

      /*
       * WL_INIT_OFFSET( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), 1)
       */
      SAC_ND_WRITE( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), 0)
        = SAC_WL_MT_SCHEDULE_START( 0) * SAC_WL_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1, 2)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,))))) == 1), 81, "Assignment with incompatible types found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 0) == 2), 81, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1, 1)
      /*
       * ND_CREATE__ARRAY__DATA( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1, 2, (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ND_WRITE_COPY( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0), )
      SAC_ND_WRITE_COPY( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1, SAC_ND_READ( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0), )

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,))))) == 0), 81, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 2, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), -4, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,))))) == 1), 81, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))))), 81, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = ( SAC_ND_A_SHAPE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), 1) * SAC_ND_READ( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 0) + SAC_ND_READ( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), 1) );
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_FREE( (SACp_emal_6782__pinl_5568__new_idx, (AKS, (NHD, (NUQ,)))), )
      /*
       * WL_ASSIGN( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,))))))), 81, "WL expression with illegal dimension found!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0)), 81, "WL expression with illegal size found!");
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), 0), (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), 0, );

      SAC_ND_FREE( (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))), )
      SAC_WL_INC_OFFSET( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), (SACp_emal_6781__pinl_5567___flat_2094, (SCL, (NHD, (NUQ,)))))
      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5569___flat_2093_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( genarray)
    SAC_ND_FREE( (SACp_wlidx_6705__pinl_5604__flat_65, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_5566___nt2ot_2124, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,))))) == 1), 813, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 0) == 1), 813, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_PRF_SHAPE__DATA( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3)
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3)"))
    SAC_ND_WRITE_COPY( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), 0), );

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_IDX_SEL__DATA( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, 0, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 1, 0)"))
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), 0, )

    SAC_ND_FREE( (SACp_emal_6779__pinl_5596___flat_73, (AKS, (NHD, (NUQ,)))), )
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "Assignment with incompatible types found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 814, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
    SAC_ND_ALLOC_BEGIN( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_ASSIGN( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), )

    SAC_PF_BEGIN_WITH( fold)
    /*
     * WL_SCHEDULE__BEGIN( 1)
     */
    {
      int SAC_WL_MT_SCHEDULE_START( 0);
      int SAC_WL_MT_SCHEDULE_STOP( 0);

      /*
       * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
       */
      SAC_WL_MT_SCHEDULE_START( 0) = 0;
      SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0);

      SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
      SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_SET_IDXVEC( 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_NOOP( )
      SAC_ND_ALLOC_BEGIN( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
      /*
       * ND_PRF_SEL__DATA_id( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, )
       */
      SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), -3, ...)"))
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "1st argument of _sel_ is not a vector!");
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))))), 814, "Length of index vector used for _sel_ does not match rank of argument array!");
      { int SAC_idx;
        SAC_idx = SAC_ND_READ( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 0);
        SAC_ND_WRITE_READ_COPY( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), SAC_idx, )
      }

      SAC_ND_COPY__DATA( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_COPY__DATA( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_CHECK_REUSE( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_NOOP()

      SAC_ND_ALLOC_BEGIN( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
      /*
       * ND_SET__SHAPE_arr( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0)
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
      SAC_NOOP()

      SAC_ND_ALLOC_END( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
      SAC_ND_INC_RC( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 1)
      SAC_ND_COPY__DATA( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), )
      SAC_ND_DEC_RC_FREE( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 1, )
      SAC_ND_PRF_SxS__DATA( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), 0))
      SAC_ND_FREE( (SACp_emal_6777__pinl_5589___flat_76, (SCL, (NHD, (NUQ,)))), )
      /*
       * ND_ASSIGN( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), 0, )
       */
      SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
      SAC_NOOP()
      SAC_NOOP()
      SAC_NOOP()
      SAC_ND_ASSIGN__DATA( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6774__pinl_6526___flat_8, (SCL, (NHD, (NUQ,)))), )

      /*
       * WL_FOLD( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))))
       */
      SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)));
      /* fold operation */

      SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
      SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
      /*
       * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
       */


      /*
       * WL_SCHEDULE__END( 1)
       */
    }

    SAC_PF_END_WITH( fold)
    SAC_ND_FREE( (SACp_emal_6778__pinl_5582___wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_5586___nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_emal_6780__pinl_5604__flat_65, (AKD, (NHD, (NUQ,)))), )
    SAC_ND_FREE( (SACp_pinl_5590___flat_74_iv, (AKS, (NHD, (NUQ,)))), )
    /*
     * WL_ASSIGN( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,))))) == (SAC_ND_A_DIM( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) - SAC_ND_A_SIZE( (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,))))))), 830, "WL expression with illegal dimension found!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SIZE( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,))))) == SAC_WL_SHAPE_FACTOR( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0)), 830, "WL expression with illegal size found!");
    SAC_ND_WRITE_READ_COPY( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), SAC_ND_READ( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), 0), (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 0, );

    SAC_ND_DEC_RC_FREE( (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_WL_INC_OFFSET( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5587__z, (SCL, (NHD, (NUQ,)))))
    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5605__flat_63_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( genarray)
  SAC_ND_FREE( (SACp_emal_6787__pinl_5598__wla_4939__flat_62, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_wlidx_6704__pinl_5602_z, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6790_TMP_32, (AKD, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5601__nt2ot_2125, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6785__pinl_5563___wla_4936__flat_2092, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,))))) == 1), 813, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 0) == 1), 813, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_PRF_SHAPE__DATA( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3)
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_SHAPE__DATA( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3)"))
  SAC_ND_WRITE_COPY( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 0, SAC_ND_A_SHAPE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), 0), );

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_PRF_IDX_SEL__DATA( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, 0, )
   */
  SAC_TR_PRF_PRINT( ("ND_PRF_IDX_SEL__DATA( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 1, 0)"))
  SAC_ND_WRITE_READ_COPY( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), 0, )

  SAC_ND_FREE( (SACp_emal_6771__pinl_5631__flat_73, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "Assignment with incompatible types found!");
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_SHAPE( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0) == 1), 814, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, 1)
  SAC_ND_ALLOC_BEGIN( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 1, 0)
  /*
   * ND_ASSIGN( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
  SAC_NOOP()
  SAC_NOOP()
  SAC_NOOP()
  SAC_ND_ASSIGN__DATA( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6866__pinl_5028__wldp_4797, (SCL, (NHD, (NUQ,)))), )

  SAC_PF_BEGIN_WITH( fold)
  /*
   * WL_SCHEDULE__BEGIN( 1)
   */
  {
    int SAC_WL_MT_SCHEDULE_START( 0);
    int SAC_WL_MT_SCHEDULE_STOP( 0);

    /*
     * MT_SCHEDULER_BEGIN( 0, 1, 0, SAC_ND_READ( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
     */
    SAC_WL_MT_SCHEDULE_START( 0) = 0;
    SAC_WL_MT_SCHEDULE_STOP( 0) = SAC_ND_READ( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0);

    SAC_WL_STRIDE_LOOP0_BEGIN( 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
    SAC_WL_GRID_UNROLL_BEGIN( 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_SET_IDXVEC( 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_NOOP( )
    SAC_ND_ALLOC_BEGIN( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,))))) == 0), 814, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 1, 0)
    /*
     * ND_PRF_SEL__DATA_id( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, )
     */
    SAC_TR_PRF_PRINT( ("ND_PRF_SEL__DATA( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), -3, ...)"))
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,))))) == 1), 814, "1st argument of _sel_ is not a vector!");
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,))))) == SAC_ND_A_SIZE( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))))), 814, "Length of index vector used for _sel_ does not match rank of argument array!");
    { int SAC_idx;
      SAC_idx = SAC_ND_READ( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 0);
      SAC_ND_WRITE_READ_COPY( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), SAC_idx, )
    }

    SAC_ND_COPY__DATA( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_COPY__DATA( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_CHECK_REUSE( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_NOOP()

    SAC_ND_ALLOC_BEGIN( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
    /*
     * ND_SET__SHAPE_arr( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0)
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
    SAC_NOOP()

    SAC_ND_ALLOC_END( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
    SAC_ND_INC_RC( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 1)
    SAC_ND_COPY__DATA( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), )
    SAC_ND_DEC_RC_FREE( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), 1, )
    SAC_ND_PRF_SxS__DATA( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), 0))
    SAC_ND_FREE( (SACp_emal_6769__pinl_5624__flat_76, (SCL, (NHD, (NUQ,)))), )
    /*
     * ND_ASSIGN( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), 0, (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), 0, )
     */
    SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,))))) == 0), 813, "Assignment with incompatible types found!");
    SAC_NOOP()
    SAC_NOOP()
    SAC_NOOP()
    SAC_ND_ASSIGN__DATA( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), (SACp_emal_6766__pinl_6532___flat_8, (SCL, (NHD, (NUQ,)))), )

    /*
     * WL_FOLD( (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))), 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), 1, (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))))
     */
    SAC_TR_WL_PRINT( ("index vector [%d] -- fold", SAC_ND_READ( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0)));
    /* fold operation */

    SAC_WL_GRID_UNROLL_END( 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, 1)
    SAC_WL_STRIDE_LOOP_END( 0, (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), 0, SAC_ND_READ( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0), 1)
    /*
     * MT_SCHEDULER_END( 0, 1, 0, SAC_ND_READ( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), 0))
     */


    /*
     * WL_SCHEDULE__END( 1)
     */
  }

  SAC_PF_END_WITH( fold)
  SAC_ND_FREE( (SACp_emal_6770__pinl_5617__wla_4814__flat_73, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5621__nt2ot_2123, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_pinl_5625__flat_74_iv, (AKS, (NHD, (NUQ,)))), )
  SAC_ND_FREE( (SACp_emal_6772__pinl_5602_z, (AKD, (NHD, (NUQ,)))), )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_pinl_5622_z, (SCL, (NHD, (NUQ,)))))
  return;
}

/*
 * ND_FUN_DEC( SACf__MAIN__plusDDD__d__d, , 3, out, double, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), in, double, (SACl_x, (SCL, (NHD, (NUQ,)))), in, double, (SACl_y, (SCL, (NHD, (NUQ,)))))
 */
void SACf__MAIN__plusDDD__d__d( SAC_ND_PARAM_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_x, (SCL, (NHD, (NUQ,)))), double), SAC_ND_PARAM_in( (SACl_y, (SCL, (NHD, (NUQ,)))), double))
{ 
  /*
   * ND_DECL( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()

  /*
   * ND_DECL( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), double, 0)
   */
  SAC_ND_DECL__DATA( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), double, )
  SAC_ND_DECL__DESC( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()


  /*
   * ND_DECL__MIRROR_PARAM( (SACl_y, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_DECL__MIRROR_PARAM( (SACl_x, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_NOTHING()

  /*
   * ND_CHECK_REUSE( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 0, (SACl_y, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
  SAC_ND_INC_RC( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_COPY__DATA( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), (SACl_y, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_DEC_RC_FREE( (SACl_y, (SCL, (NHD, (NUQ,)))), 1, )
  /*
   * ND_CHECK_REUSE( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 0, (SACl_x, (SCL, (NHD, (NUQ,)))), 0, )
   */
  SAC_NOOP()

  SAC_ND_ALLOC_BEGIN( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
  /*
   * ND_SET__SHAPE_arr( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 0)
   */
  SAC_ASSURE_TYPE_LINE( (SAC_ND_A_DIM( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,))))) == 0), 122, "Assignment with incompatible types found!");
  SAC_NOOP()

  SAC_ND_ALLOC_END( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 0, 0)
  SAC_ND_INC_RC( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 1)
  SAC_ND_COPY__DATA( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), (SACl_x, (SCL, (NHD, (NUQ,)))), )
  SAC_ND_DEC_RC_FREE( (SACl_x, (SCL, (NHD, (NUQ,)))), 1, )
  SAC_ND_PRF_SxS__DATA( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), SAC_PRF_BINOP, +, SAC_ND_READ( (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))), 0), SAC_ND_READ( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), 0))
  SAC_ND_FREE( (SACp_emal_6876__pinl_5632__flat_8, (SCL, (NHD, (NUQ,)))), )
  /*
   * ND_FUN_RET( , 1, out, (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))))
   */
  SAC_ND_RET_out( (SAC_arg_1, (SCL, (NHD, (NUQ,)))), (SACp_emal_6875__pinl_5633__flat_8, (SCL, (NHD, (NUQ,)))))
  return;
}

int main( int __argc, char *__argv[])
{
  SAC_ND_DECL__DATA( (SAC_res, (SCL, (NHD, (NUQ,)))), int, )
  SAC_ND_DECL__DESC( (SAC_res, (SCL, (NHD, (NUQ,)))), )
  SAC_NOTHING()
  SAC_MT_SETUP_INITIAL();
  SAC_PF_SETUP();
  SAC_HM_SETUP();
  SAC_MT_SETUP();
  SAC_CS_SETUP();
  SACf__MAIN__main( SAC_ND_ARG_out( (SAC_res, (SCL, (NHD, (NUQ,))))));

  SAC_PF_PRINT();
  SAC_CS_FINALIZE();
  SAC_HM_PRINT();

  return( SAC_ND_READ( (SAC_res, (SCL, (NHD, (NUQ,)))), 0));
}
